<?php

/*
Plugin Name: WP Zon Builder
Plugin URI: http://www.wpzonbuilder.com/
Description: Absolutely the best, most powerful plugin available for Amazon Associates. Turn WordPress into a full-featured, powerful, and search engine-friendly Amazon affiliate site. 
Version: 2.5b
Author: WP Zon Builder
Author URI: http://www.wpzonbuilder.com
*/

include "config.php";
amzn_include_tarzan();

add_action("admin_menu", "amzn_add_menus");
add_action("admin_head", "amzn_admin_css_scripts");
add_action("wp_head", "amzn_css_scripts");


function amzn_add_menus() {
	
    add_menu_page('Add Products', 'WPZonBuilder', 'manage_options', __FILE__, 'amzn_home', WP_PLUGIN_URL."/amzn/icon.png");

    add_submenu_page(__FILE__, 'WPZonBuilder Home', 'Home', 'manage_options', __FILE__, 'amzn_home');

    add_submenu_page(__FILE__, 'WPZonBuilder Add To Queue', 'Add To Queue', 'manage_options', 'amzn_queue_products', 'amzn_queue_products');
    
    add_submenu_page(__FILE__, 'WPZonBuilder Post Products', 'Post Products', 'manage_options', 'amzn_post_products', 'amzn_post_products');
    
    add_submenu_page(__FILE__, 'WPZonBuilder General Settings', 'General Settings', 'manage_options', 'amzn_general_settings_page', 'amzn_general_settings_page');
    add_submenu_page(__FILE__, 'WPZonBuilder AWS/Affiliate Settings', 'AWS/Aff. Settings', 'manage_options', 'amzn_settings_page', 'amzn_settings_page');
    add_submenu_page(__FILE__, 'WPZonBuilder Language Settings', 'Language Settings', 'manage_options', 'amzn_language_settings_page', 'amzn_language_settings_page');
    add_submenu_page(__FILE__, 'WPZonBuilder Integration Settings', 'Integration', 'manage_options', 'amzn_integration_settings_page', 'amzn_integration_settings_page');
    
    add_submenu_page(__FILE__, 'WPZonBuilder Click Reports', 'Click Reports', 'manage_options', 'amzn_click_reports', 'amzn_click_reports');
    
    add_submenu_page(__FILE__, 'WPZonBuilder Documentation', 'Documentation', 'manage_options', 'amzn_docs', 'amzn_docs');
    
    // add a recommended resources page here
    
}

function amzn_plugin_option($option) {
	$info = get_plugin_data(__FILE__);
	if (isset($info[$option])) {
		return $info[$option];
	}
	return NULL;
}

function amzn_admin_css_scripts() {

	echo "<script src='".WP_PLUGIN_URL."/amzn/adminscript.js"."' language='javascript'></script>";
	echo "<link rel='stylesheet' href='".WP_PLUGIN_URL."/amzn/adminstyle.css"."'>";

}

function amzn_include_tarzan() {
	require('tarzan/tarzan.class.php');
}


include "amznhelper.php";
include "amznhome.php";
include "amznqueueproducts.php";
include "amznpostproducts.php";
include "amznshortcodes.php";
include "amznsettings.php";
include "amznstars.php";
include "amzntemplates.php";
include "amznproductdata.php";
include "amznmetaboxes.php";
include "amznrewrite.php";
include "amznclickreports.php";
include "amznoverridetrack.php";
include "amznyoutube.php";
include "amzndupes.php";
include "amznwidgets.php";
include "amznenterkeys.php";
include "amznmicroformat.php";
include "amznlinkimages.php";
include "amzngallery.php";
include "amznuserreview.php";
include "amznonsitecart.php";
include "amznthumbnails.php";
include "amznxpath.php";
include "amznfunctions.php";

include "amzndocs.php";

register_activation_hook(__FILE__, 'amzn_activate');

function amzn_activate() {

	global $wpdb;

	$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."amznclicks` (
	`id` int(10) NOT NULL auto_increment,
	`ip` varchar(255) NOT NULL,
	`postid` int(10) NOT NULL,
	`destination` varchar(255) NOT NULL,
	`title` varchar(255) NOT NULL,
	`asin` varchar(255) NOT NULL,
	PRIMARY KEY  (`id`)
	)");
	

	update_option('amzn-apiratinganyway', 'Yes');

	update_option('amzn-aws_locale', 'us');

	update_option('amzn-template_group', 'default');
	update_option('amzn-length_of_excerpt', '150');
	update_option('amzn-excerpt_link', "...<br /><a href='[permalink]'>Read More</a>");
	update_option('amzn-excerpts-short', 'Yes');

	update_option('amzn-localthumbs', 'Yes');
	
	update_option('amzn-displaymoreinformation', 'Yes');

	update_option('amzn-tags_posts', 'Yes');
	update_option('amzn-tags_posts', 3);

	update_option('amzn-empty_product_description', 'No description available.');
	update_option('amzn-empty_features', 'No features available.');
	update_option('amzn-empty_manufacturer', 'unspecified');
	update_option('amzn-empty_availability', 'unspecified');
	update_option('amzn-empty_list_price', 'unavailable');
	update_option('amzn-empty_lowest_new_price', 'Too low to display.');
	update_option('amzn-supersaveryes', 'Eligible For Free Shipping');
	update_option('amzn-ratethis', 'Rate This<br />');

	update_option('amzn-moreinfoimg', 'moreinfo-legacy.png');
	update_option('amzn-addtocartimg', 'addtocart-legacy.png');

	update_option('amzn-cartkey', md5(time()));

	update_option('amzn-onsitecart_windowtitle', 'Shopping Cart');
	update_option('amzn-onsitecart_quantity', 'Quantity');
	update_option('amzn-onsitecart_item', 'Item');
	update_option('amzn-onsitecart_price', 'Price');
	update_option('amzn-onsitecart_subtotal', 'Sub Total');
	update_option('amzn-onsitecart_total', 'Total');
	update_option('amzn-onsitecart_remove', 'Remove');
	update_option('amzn-onsitecart_updateqty', 'Update Qty');
	update_option('amzn-onsitecart_continueshopping', 'Continue Shopping');
	update_option('amzn-onsitecart_checkout', 'Checkout');
	update_option('amzn-onsitecart_pricedisclaimer', 'The price shown is the list price. Click Checkout to continue to Amazon to see the lowest price.');
	update_option('amzn-onsitecart_empty', 'Your cart is empty.');
	update_option('amzn-onsitecart_viewcart', 'View Cart');
	update_option('amzn-onsitecart_currentlyx', 'There are currently %% items in your cart.');

	update_option('amzn-oldstyleprice', 'Yes');


	update_option('amzn-carttheme', 'smoothness');

	$wpdb->query("ALTER TABLE `".$wpdb->prefix."amznclicks` ADD `time` INT( 10 ) NOT NULL , ADD `useragent` VARCHAR( 255 ) NOT NULL");

}

