<?php

function amzn_docs() {

?>

<?php amzn_enterkeys(); ?>

<div class='wrap'>

<h2>Online Documentation & FAQ</h2>

<p>
<b>Visit <a href='http://www.wpzonbuilder.com/tutorials-documentation/'>http://www.wpzonbuilder.com/tutorials-documentation/</a> for online documentation, video tutorials, and answers to common questions.</b>
</p>

<br />

<h2>General Setup</h2>

<p>
Once you have installed the plugin, the first thing you need to do is enter your Amazon AWS Keys and Associate ID on the <b>WPZonBuilder -> AWS Settings</b> page. You must do this before you will be able to add products from Amazon to your blog.
</p>

<br />


<h2>
Adding Products
</h2>

<p>
To add products, go to the <b>WPZonBuilder -> Add To Queue</b> page. From here, you can search Amazon&#039;s database of products. Click "Add To Queue" next to the products you wish to add to your site. This will not add it to your site immediately, it will add it to the queue. Do this for as many products as you wish.
</p>

<p>
Now go to <b>WPZonBuilder -> Post Products</b>. This will post all of the products in the queue to your blog. Look over the settings on this page. They all should be self-explanatory, and in most cases you won&#039;t need to change them. But they do some cool stuff, so it is definitely worth looking them over.
</p>


<br />
<h2>
Integration
</h2>

<p>
Why limit yourself to promoting Amazon products? Using <a href='http://www.phpbay.com/' target='_blank'>phpBay</a>, <a href='http://www.phpostock.com/' target='_blank'>phpOStock</a>, and other WordPress plugins, you can get display products from eBay, Overstock.com, and more.
</p>

<p>
These plugins use <a href='http://en.support.wordpress.com/shortcodes/' target='_blank'>WordPress shortcodes</a> to display product data. Enter the shortcodes on the <b>WPZonBuilder -> Integration</b> page. These will be used as the defaults. You can change these on a per-post basis, or modify them on the Post Products page.
</p>

<br />
<h2>Template Documentation</h2>

<p>
The templates are located in the <code>/wp-content/plugins/amzn/templates/*template-set-name*/</code> folder. It is recommended you do not edit the default template files. Instead, copy the default template folder to <code>/wp-content/plugins/amzn/templates/default2/</code>, and then edit the copied files. Change to the "default2" template set on the <b>WPZonBuilder -> General Settings</b> page.
</p>

<p>
The WPZonBuilder templating system makes use of HTML files with template tags to control the look and feel of Amazon product posts. If you want to change the way the product information is displayed on your site, you can edit these files.
</p>

<p>
<b>There are 12 template files, and one template CSS file.</b><br /><br />

MAIN TEMPLATES<br />
<i>single.html</i> - used for individual post pages<br />
<i>short.html</i> - used for excerpts<br />
<i>video.html</i> - used for video reviews<br />
<i>inlinesingle.html</i> - used for the inline single product shortcode<br />
<i>inlinemulti.html</i> - used for the inline multiple product shortcode<br />
<i>comment.html</i> - used for user reviews/comments<br />
<br />

WIDGETS<br />
<i>accessorywidget.html</i> - used for the product accessories sidebar widget<br />
<i>accessorywidgettitle.html</i> - the title of the product accessories sidebar widget<br />
<i>categorywidget.html</i> - used for the category sidebar widget<br />
<i>categorywidgettitle.html</i> - the title of the category sidebar widget<br />
<i>similarwidget.html</i> - used for the similar products sidebar widget<br />
<i>similarwidgettitle.html</i> - the title of the similar products sidebar widget<br />
<br />

CSS<br />
<i>style.css</i> - the CSS file - always included<br />
</p>


<p>
<b>Template Tags:</b> Template tags are in the format <code>[tag-name]</code>. They are replaced with the relevant data by the plugin. Open the template files to see the available template tags and how and where they are used.
</p>



<h2>
Backup Frequently
</h2>

<p>
	Seriously, do it. If you do not know how to backup your site, ask your host.
</p>

</div>

<?php

}

?>