<?php

add_action("init", "amzn_gallery_jquery");

function amzn_gallery_jquery() {
	if (!is_admin()) {
		wp_enqueue_script('jquery');
	}
}


add_action("wp_head", "amzn_gallery_head");

function amzn_gallery_head() {

	if (get_option("amzn-fancybox") == "Yes") {

		global $post;

		if (is_single() || is_page()) {

			$ASIN = get_post_meta($post->ID, 'amzn_ASIN', true);

			if (!$ASIN) {
				return "";
			}

			$js = "
			<script type='text/javascript' src='".WP_PLUGIN_URL."/amzn/fancybox/jquery.fancybox-1.2.6.pack.js'></script>
			<link rel='stylesheet' href='".WP_PLUGIN_URL."/amzn/fancybox/jquery.fancybox-1.2.6.css' type='text/css' media='screen' />
			
			<script>
				jQuery(function() {

//					jQuery('#amzngalleryloading').hide('slow');

					jQuery('a.amznfancybox').fancybox({
						'transitionIn'	:	'elastic',
						'transitionOut'	:	'elastic',
						'speedIn'		:	600,
						'speedOut'		:	200,
						'overlayShow'	:	false
					});

					jQuery('#amzngallery').show('slow');

				});
			</script>";

			echo $js;
			
		}

	}


}

function amzn_build_gallery($ImageSets) {

	$galleryhtml = "";
	$galleryhtml .= "<div id='amzngallery' align='center' style='display: none;'>";

	if (isset($ImageSets['ImageSet']['SwatchImage']) || isset($ImageSets['ImageSet']['MediumImage'])) {

		$img = $ImageSets['ImageSet'];

		$limgurl = $img['LargeImage']['URL'];
		$mimgurl = $img['SmallImage']['URL'];

		$limgurl = str_replace("_SL", "_AA", $limgurl);
		$mimgurl = str_replace("_SL", "_AA", $mimgurl);

		$galleryhtml .= '<a href="'.$limgurl.'" class="amznfancybox" rel="gallery_amzn"><img class="amzn_gallery_img" src="'.$mimgurl.'" /></a>';

		return "";

	} else {

		if ( ! count($ImageSets['ImageSet'])) {

		} else {

			foreach ($ImageSets['ImageSet'] as $img) {

				$limgurl = $img['LargeImage']['URL'];
				$mimgurl = $img['SmallImage']['URL'];

				// $limgurl = str_replace("_SL", "_AA", $limgurl);
				$mimgurl = str_replace("_SL", "_AA", $mimgurl);

				$galleryhtml .= '<a target="_blank" href="'.$limgurl.'" class="amznfancybox" rel="gallery_amzn"><img style="margin: 8px; border: 4px solid #ddd;" src="'.$mimgurl.'" /></a>';

			}
		}
	}

	$galleryhtml .= "</div>";

	return $galleryhtml;

}
