<?php
/**
 * Useful generic methods
 */

function amzn_read_array($arr, $key, $default = NULL)
{
	return isset($arr[$key]) ? $arr[$key] : $default;
}
function amzn_read_request($key, $default = NULL)
{
	return amzn_read_array($_REQUEST, $key, $default);
}
function amzn_read_post($key, $default = NULL)
{
	return amzn_read_array($_POST, $key, $default);
}

function amzn_file_get_contents($url, & $charset = NULL, & $content_type = NULL) {

	$content_type = NULL; $charset = NULL; $response_header = array(); $contents = FALSE;
	
	if (preg_match('%^\w+://%i', $url) and function_exists('curl_init')) { // CURL library is preferable
		$c = curl_init();
		curl_setopt($c, CURLOPT_URL, $url);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($c, CURLOPT_HEADER, true);
		
		$response = curl_exec($c);
		if ($response) {
			$header_size = curl_getinfo($c, CURLINFO_HEADER_SIZE);
			$response_headers = substr($response, 0, $header_size);
			$contents = substr($response, $header_size);
	
			// Parse out the headers
			$response_headers = explode("\r\n\r\n", trim($response_headers));
			$response_headers = array_pop($response_headers);
			$response_headers = explode("\r\n", $response_headers);
			array_shift($response_headers);
		}
		curl_close($c);
		
	} else {
		$contents = file_get_contents($url);
		$response_headers = $http_response_header;
	}
	
	if (FALSE !== $contents) foreach ($response_headers as $header) {
		if (preg_match('%^Content-Type:%i', $header)) {
			$content_type = $header;
			if (preg_match('%charset=([^;]*)%i', $header, $mtch)) {
				$charset = $mtch[1];
			}
		}
	}
	
	return $contents;
	
}