<?php

add_action('admin_menu', 'amzn_add_metaboxes');
add_action('save_post', 'amzn_save_postdata');

/* Adds a custom section to the "advanced" Post and Page edit screens */
function amzn_add_metaboxes() {

	$postid = isset($_REQUEST["post"]) ? $_REQUEST["post"] : '';
	$ASIN = '';
	$amzn_ccfromhere = '';
	
	if (isset($_REQUEST["action"]) and $_REQUEST["action"] == "edit") {
		$ASIN = get_post_meta($postid, 'amzn_ASIN', true);
		$amzn_ccfromhere = get_post_meta($postid, 'amzn_ccfromhere', true);
	}

	if ( ($ASIN == "" && $postid != '' ) || $amzn_ccfromhere == "yes") {
		add_meta_box( 'amzn_makeitamzn', 'WPZonBuilder: Create Product Post', 'amzn_makeitamzn_inner', 'post', 'side' , 'high' );
		add_meta_box( 'amzn_makeitamzn', 'WPZonBuilder: Create Product Post', 'amzn_makeitamzn_inner', 'page', 'side' , 'high' );
	}

	add_meta_box( 'amzn_sidebarbox', 'WPZonBuilder: Menu', 'amzn_sidebar_inner', 'post', 'side' , 'high' );
	add_meta_box( 'amzn_sidebarbox', 'WPZonBuilder: Menu', 'amzn_sidebar_inner', 'page', 'side' , 'high' );

	if ($ASIN != "") {
		add_meta_box( 'amzn_youtubebox', 'WPZonBuilder: YouTube Reviews', 'amzn_youtube_inner', 'post', 'side' , 'high' );
		add_meta_box( 'amzn_youtubebox', 'WPZonBuilder: YouTube Reviews', 'amzn_youtube_inner', 'page', 'side' , 'high' );
	}

	add_meta_box( 'amzn_shortcodebox', 'WPZonBuilder: Insert Products Inline', 'amzn_shortcodebox_inner', 'post', 'normal' , 'high');
	add_meta_box( 'amzn_shortcodebox', 'WPZonBuilder: Insert Products Inline', 'amzn_shortcodebox_inner', 'page', 'normal' , 'high');

}




function amzn_sidebar_inner() {

	global $post;
	$ASIN = get_post_meta($post->ID, 'amzn_ASIN', true);

	echo '<input type="hidden" name="amzn_noncename" id="amzn_noncename" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

	if ($ASIN != "") {
		?>

		<div style='font-size: 14px; margin-bottom: 0px; font-weight: bold;'>Update Data</div><br />

		<input type='checkbox' name='amzn_refresh' id='amzn_refresh' value='Yes'>
		<label onclick="selectradiololz('amzn_refresh');">Refresh Product Data From Amazon</label><br />
		<br /><br />

		Affiliate ID<br />
		<input type='text' name='amzn_newid' value='<?php echo get_post_meta($post->ID, "amzn_overridetrack", true); ?>'><br />
		<small>Leave blank and the affiliate ID will not be changed/will be reset to what it was when the post was created.</small>

		<input type='hidden' name='amzn_post_id' value='<?php echo $post->ID; ?>'>

		<small>
			You must save/update the post for these changes to take effect.
		</small>

		<br /><br /><br />
		<div style='font-size: 14px; margin-bottom: 0px; font-weight: bold;'>Post Stats</div><br />

		<?php

	}

	$postid = $post->ID;
	$cc = get_post_meta($post->ID, "amzn_ClickCount", true);

	echo "Clicks Sent<br />";
	echo "<input type='text' name='amzn_newclicks' value='".$cc."'>";
	echo "<br />";

	?>

	<small>
		This is how many clicks this particular post has sent to Amazon. Change this to 0 and save the post to reset this.
	</small>
	
	
		<br /><br /><br />
		<div style='font-size: 14px; margin-bottom: 0px; font-weight: bold;'>SEO: Automatic Bolding</div><br />
		Enter one keyword per line. These keywords will automatically be bolded (surrounded with &lt;strong&gt; tags) in the product description.<br />
		<textarea rows='5' cols='20' name='amzn_autobold_textarea'><?php echo get_post_meta($post->ID, "amzn_autobold", true); ?></textarea>
		

	<?php

}



function amzn_save_postdata( $post_id ) {

	// verify some stuff
	if ( ! wp_verify_nonce(amzn_read_post('amzn_noncename'), plugin_basename(__FILE__))) return;
	if ( DOING_AUTOSAVE && defined('DOING_AUTOSAVE')) return;
	if ( ! current_user_can('edit_post', $post_id)) return;

	// cool

	$newclicks = amzn_read_post("amzn_newclicks");
	update_post_meta($post_id, 'amzn_ClickCount', (string) $newclicks);

	$yturls = amzn_read_post("amzn_yturls");
	update_post_meta($post_id, 'amzn_yturls', (string) $yturls);

	if (amzn_read_post("amzn_newid", "") == "") {
		$amzn_newid = null;
		update_post_meta($post_id, 'amzn_overridetrack', '');
	} else {
		$amzn_newid = $_POST["amzn_newid"];
		update_post_meta($post_id, 'amzn_overridetrack', (string) $amzn_newid);
	}

	if (amzn_read_post("amzn_refresh") == "Yes") {

		$ASIN = get_post_meta($_POST["amzn_post_id"], 'amzn_ASIN', true);
		$aaws = new AmazonAAWS(null, null, null);

		$product_data = amzn_get_product_data($ASIN, $aaws); // extract($product_data);

		amzn_product_to_meta($post_id, $product_data);
	}

	if (amzn_read_post("amzn_makeit_amzn") == "Yes") {

		$postid = $_POST["amzn_makeit_post_id"];
		$newasin = $_POST["amzn_makeit_asin"];
		update_post_meta($postid, 'amzn_ASIN', (string) $newasin);
		update_post_meta($postid, 'amzn_ccfromhere', "yes");

		$aaws = new AmazonAAWS(null, null, null);
		
		$product_data = amzn_get_product_data($newasin, $aaws);
		amzn_product_to_meta($postid, $product_data);

		extract($product_data);

		// ------------------------
		if (get_option("amzn-localthumbs") == "Yes") {
			if ($LargeImageURL) {
				newpref_generate_post_thumb($LargeImageURL, $postid);
			} else if (!$LargeImageURL) {
				if ($MediumImageURL) {
					newpref_generate_post_thumb($MediumImageURL, $postid);
				} else if (!$MediumImageURL) {
					newpref_generate_post_thumb($SmallImageURL, $postid);
				}
			}
		}
		// ------------------------

	}
	
	update_post_meta($post_id, 'amzn_autobold', (string) $_POST["amzn_autobold_textarea"]);

}


function amzn_youtube_inner() {

	global $post;
	$yturls = get_post_meta($post->ID, 'amzn_yturls', true);
	?>

	<a href='http://www.youtube.com/' target='_blank'>Find YouTube video reviews</a>

	<br /><br />

	Enter URLs to video reviews one per line.<br />
	You can also use video IDs:<br />
	<code style='position: relative; top: 5px;'>(youtube.com/watch?v=-THIS-IS-THE-ID-)</code><br /><br />
	<textarea rows='8' cols='30' style='width: 255px; font-size: 9px;' name='amzn_yturls'><?php echo $yturls; ?></textarea>

	<?php
}


function amzn_shortcodebox_inner() {
	?>

	<table><tr>
	<td width='50%' style='padding-right: 24px;'>

		<b>Insert Inline Product</b><br />
		<small>Find products at <a href='http://www.amazon.com/' target='_blank'>http://www.amazon.com/</a></small><br />
		Product ASIN: <input type='text' value='' id='scb_asin' /><br /><br />

	</td>
	</tr></table>

	<input type='button' class='button' onclick='single_insert();' value='Insert &raquo;' /> or enter shortcode manually: <code>[amzn_product_inline asin='ASINGOESHERE']</code>

	<script>
	function single_insert() {


		scbscb = "[amzn_product_inline asin='" + document.getElementById("scb_asin").value + "']";

		tinyMCE.execInstanceCommand('content','mceInsertContent',false,scbscb);

	}
	</script>

	<table><tr>
	<td width='50%' style='padding-right: 24px;'>

		<b>Insert Amazon Search Results</b><br />

		Search Keywords: <input type='text' value='' id='scb_keyword' /><br />
		Number of Products: <input type='text' value='' id='scb_count' /><br />
		Results Page: <input type='text' value='' id='scb_page' /><br />
		Sort Order: <input type='text' value='' id='scb_sort' /><br />
		Product Category: <input type='text' value='' id='scb_category' /><br />

	</td>
	</tr></table>

	<input type='button' class='button' onclick='multi_insert();' value='Insert &raquo;' /></span> or enter shortcode manually: <code>[amzn_multi_product_inline keyword='keywords' count='5' page='1' sort='default' category='Books']</code>

	<br /><small><b>Get possible sort and category (SearchIndex) values <a href='http://docs.amazonwebservices.com/AWSECommerceService/2007-10-29/DG/APPNDX_SortValuesArticle.html' target='_blank'>here</a>. Alternatively, to determine SearchIndex values, take any item in the SearchIndex box on the Add To Queue page and remove all special characters and spaces - i.e. "Home & Garden" would become "HomeGarden"</b></small>

	<script>
	function multi_insert() {


		scbscb = "[amzn_multi_product_inline keyword='" + document.getElementById("scb_keyword").value + "' count='" + document.getElementById("scb_count").value + "' page='" + document.getElementById("scb_page").value + "' sort='" + document.getElementById("scb_sort").value + "' category='" + document.getElementById("scb_category").value + "']";

		tinyMCE.execInstanceCommand('content','mceInsertContent',false,scbscb);

	}
	</script>

	<?php

}


function amzn_makeitamzn_inner() {

	global $post;

	echo '<input type="hidden" name="amzn_noncename2" id="amzn_noncename2" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

	$amzn_ccfromhere = get_post_meta($post->ID, 'amzn_ccfromhere', true);

	if ($amzn_ccfromhere !="yes") {
	    ?>

		<input type='checkbox' name='amzn_makeit_amzn' id='amzn_makeit_amzn' value='Yes'>
		<label onclick="selectradiololz('amzn_makeit_amzn');">Make This Post An Amazon Product Post</label><br />

		<br /><br />

		Product ASIN<br />
		<input type='text' name='amzn_makeit_asin' value=''><br />

		<input type='hidden' name='amzn_makeit_post_id' value='<?php echo $post->ID; ?>'>

		<small>
			You must save/update the post for the post to be converted to an Amazon Product Post. <b>There is no way to undo this.</b>
		</small>

		<?php
	} else {
		?>

		You must include <code>[amzn_product_post]</code> somewhere in your post text to display the product data. <br /><br />
		<small>Advanced users: you can specify an optional template attribute with the name of the template file you would like to use, if other than the default, for any WP Zon Builder shortcode, i.e. <br /><br /><code>[amzn_product_post template='exampletemplate']</code></small>
		
		<?php
	}
}
