<?php

include "cart/CookieShoppingCart.php";

function amzn_onsitecart_jquery() {
	if (get_option('amzn-onsitecart') == 'Yes') {
	    wp_enqueue_script('jquery');
	}
}


function amzn_onsitecart_head() {
	
	if (get_option('amzn-onsitecart') == 'Yes') {

		// only do this on a page the cart could be used on?
		$styleurl = WP_PLUGIN_URL."/amzn/cart/cart.css";
		echo "<link rel='stylesheet' href='".$styleurl."' />";
		// --------------
		
		$waitgif = WP_PLUGIN_URL."/amzn/ajax-loader.gif";
		
		// option to choose jquery UI stylesheet
		// have option to disable jquery ui, period, regardless of whether admin panel or not. what if some other plugin is including it the wrong way and being mean.
		if ( !is_admin() ) {
			?>
			<script type="text/javascript" src="http://www.google.com/jsapi"></script>
			<script>
			google.load("jqueryui", "1.8.2");
			</script>
			
			<?php
			$jqueryuitheme = get_option('amzn-carttheme');			
			?>

			<link rel='stylesheet' href='http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/<?php echo $jqueryuitheme; ?>/jquery-ui.css' type='text/css'>

			<script>
			var custom_dialog = (jQuery.browser.msie) ? true : false;
			
			jQuery(document).ready(function(){

				if (custom_dialog) {
					var underlay_div = "<div id='amzncartdiv_underlay' style='display:none; position:absolute; top:0; left:0; margin:0; padding:0; z-index:1001; background-color:#CCC; filter:alpha(opacity=30);'></div>";
					
					jQuery(underlay_div).appendTo("body");
					
				}
				
				jQuery("<div id='amzncartdiv'>Shopping Cart</div>").appendTo("body");
				
				jQuery("#amzncartdiv").dialog({
					title: "<?php echo get_option('amzn-onsitecart_windowtitle'); ?>",
					modal: !(custom_dialog),
					resizable: true,
					width: 670,
					height: 400,
					autoOpen: false
				});
				
		/*	Make the Shopping Cart follow the scroll */
		//	{
				var cartdivwrapper = document.getElementById("amzncartdiv").parentNode;
				cartdivwrapper.style.position = 'fixed';
				cartdivwrapper.style.top = '25%';
				cartdivwrapper.style.width = '25%';
		//	}
				
				if (custom_dialog) {
					jQuery("#amzncartdiv").bind("dialogopen", function(event, ui) {
						var underlay = jQuery("#amzncartdiv_underlay");
						underlay.css('height', jQuery(document).height() + 'px');
						underlay.css('width', jQuery(document).width() + 'px');
						underlay.show();
					});
				}

				jQuery("#amzncartdiv").bind("dialogbeforeclose", function(event, ui) {
					location.reload();
				});

				jQuery(".amzn_addtocart_onsite_link").click(function (e) {
					e.preventDefault();
				});

			});

			function amzn_onsitecartQty(postid) {

				qty = jQuery("#qtyfor_" + postid).val();

				amzn_cartLoading();

				jQuery.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>", 
					type:'POST',
					data:'action=amzn_onsitecart_qtyproduct&postid=' + postid + '&qty=' + qty,

					success:function(results) {
						amzn_onsitecartShow();
					}

				});

			}



			function amzn_onsitecartRemove(postid) {

				amzn_cartLoading();

				jQuery.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>", 
					type:'POST',
					data:'action=amzn_onsitecart_removeproduct&postid=' + postid,

					success:function(results) {
						amzn_onsitecartShow();
					}

				});

			}

			function amzn_cartLoading() {

				waithtml = "<center><br /><br /><img src='<?php echo $waitgif ?>' /></center>";
				jQuery("#amzncartdiv").dialog("open");
				jQuery("#amzncartdiv").html(waithtml);

			}


			function amzn_onsitecartAdd(postid) {

				amzn_cartLoading();

				jQuery.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>", 
					type:'POST',
					data:'action=amzn_onsitecart_addproduct&postid=' + postid,

					success:function(results) {
						amzn_onsitecartShow();
					}

				});

			}

			function amzn_onsitecartShow() {

				amzn_cartLoading();

				jQuery.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>", 
					type:'POST',
					data:'action=amzn_onsitecart_showcart',

					success:function(results) {

						jQuery("#amzncartdiv").html(results);

						jQuery("#amzncart_continueshopping").button();
						jQuery("#amzncart_checkout").button();

					}

				});

			}


			</script>

			<?php
		}
		
	}
	
}


add_action('init', 'amzn_onsitecart_jquery');
add_action('wp_head', 'amzn_onsitecart_head');


add_action('wp_ajax_amzn_onsitecart_addproduct', 'amzn_onsitecart_addproduct');
add_action('wp_ajax_nopriv_amzn_onsitecart_addproduct', 'amzn_onsitecart_addproduct');

add_action('wp_ajax_amzn_onsitecart_removeproduct', 'amzn_onsitecart_removeproduct');
add_action('wp_ajax_nopriv_amzn_onsitecart_removeproduct', 'amzn_onsitecart_removeproduct');

add_action('wp_ajax_amzn_onsitecart_qtyproduct', 'amzn_onsitecart_qtyproduct');
add_action('wp_ajax_nopriv_amzn_onsitecart_qtyproduct', 'amzn_onsitecart_qtyproduct');

add_action('wp_ajax_amzn_onsitecart_showcart', 'amzn_onsitecart_showcart');
add_action('wp_ajax_nopriv_amzn_onsitecart_showcart', 'amzn_onsitecart_showcart');

add_action('wp_ajax_amzn_onsitecart_formaj', 'amzn_onsitecart_formaj');
add_action('wp_ajax_nopriv_amzn_onsitecart_formaj', 'amzn_onsitecart_formaj');


function amzn_onsitecart_formaj() {
	
	$postid = intval($_REQUEST["postid"]);
	
	$ShoppingCart = new CookieShoppingCart();
	$cartcontents = $ShoppingCart->getCart(true);
	
	amzn_onsitecart_form('amzn_onsitecart_form_widget', $cartcontents);
	
	die();

}


function amzn_onsitecart_addproduct() {
	
	$postid = intval($_REQUEST["postid"]);
	
	$asin = get_post_meta($postid, "amzn_ASIN", true);
	
	if (!$asin || $asin == "") {
		echo "not an Amazon product post";
	} else {
		$ShoppingCart = new CookieShoppingCart();
		$ShoppingCart->addToCart($postid);
	}
	
	die();
}



function amzn_onsitecart_removeproduct() {
	
	$postid = intval($_REQUEST["postid"]);
	
	$asin = get_post_meta($postid, "amzn_ASIN", true);
	
	if (!$asin || $asin == "") {
		echo "not an Amazon product post";
	} else {
		$ShoppingCart = new CookieShoppingCart();
		$ShoppingCart->removeFromCart($postid);
	}
	
	die();
}


function amzn_onsitecart_qtyproduct() {
	
	$postid = intval($_REQUEST["postid"]);
	$qty = intval($_REQUEST["qty"]);

	$asin = get_post_meta($postid, "amzn_ASIN", true);
	
	if (!$asin || $asin == "") {
		echo "not an Amazon product post";
	} else {
		$ShoppingCart = new CookieShoppingCart();
		$ShoppingCart->addToCart($postid, $qty, true);
	}
	
	die();
}


function amzn_onsitecart_showcart() {
	$ShoppingCart = new CookieShoppingCart();
	$cartcontents = $ShoppingCart->getCart(true);
	?>
	
	<div style='background-color: #fff;'>
	
	<table class='amzncart_table'>
		<tr class='amzncart_table_toptr'>
			<td class='amzncart_table_qty_top'>
				<?php echo get_option('amzn-onsitecart_quantity'); ?>
			</td>
			<td class='amzncart_table_links_top'>
				
			</td>
			<td class='amzncart_table_item_top'>
				<?php echo get_option('amzn-onsitecart_item'); ?>
			</td>
			<td class='amzncart_table_price_top'>
				<?php echo get_option('amzn-onsitecart_price'); ?>
			</td>
			<td class='amzncart_table_subtotal_top'>
				<?php echo get_option('amzn-onsitecart_subtotal'); ?>
			</td>
		</tr>

		<?php
		$totalamounts = array();
		$totalformats = array();
		$count = 0;
		
		foreach ($cartcontents as $postid => $qty) {
			
			if (!$postid) continue;
			if (!get_post_meta($postid, "amzn_ASIN", true)) continue;
			
			$count++;
			?>
		
			<tr class='amzncart_table_contenttr' id='amzncart_table_contenttr_<?php echo $postid; ?>'>
				<td class='amzncart_table_qty'>
					<input type='text' id='qtyfor_<?php echo $postid; ?>' value='<?php echo $qty; ?>'>
					
					<script>
					// jQuery("#qtyfor_<?php echo $postid; ?>").val("<?php echo $qty; ?>");
					</script>
					
				</td>
				<td class='amzncart_table_links'>
					<a href='#' onClick='amzn_onsitecartRemove("<?php echo $postid; ?>");'><?php echo get_option('amzn-onsitecart_remove'); ?></a> / <a href='#' onClick='amzn_onsitecartQty("<?php echo $postid; ?>");'><?php echo get_option('amzn-onsitecart_updateqty'); ?></a>
				</td>
				<td class='amzncart_table_item'>
					<a href='<?php echo get_permalink($postid); ?>'><?php echo get_post_meta($postid, "amzn_Title", true); ?></a>
				</td>
				<td class='amzncart_table_price'>
					<?php 
					
					$itempricelp = get_post_meta($postid, "amzn_ListPrice", true); 
					$itempricecp = get_post_meta($postid, "amzn_LowestNewPrice", true); 
					
					if ($itempricecp) {
						$itempricelp = $itempricecp;
					}

					if ($itempricelp) {
						echo $itempricelp;
					} else {
						echo "price unavailable";
					}
					
					?>
				</td>
				<td class='amzncart_table_subtotal'>
					<?php
					if ($itempricelp) {
						$subtotalamount = AmazonAAWS_Locale::price_to_float($itempricelp, $symbol, $format) * $qty;
						isset($totalamounts[$symbol]) or $totalamounts[$symbol] = 0;
						isset($totalformats[$symbol]) or $totalformats[$symbol] = $format;
						$totalamounts[$symbol] += $subtotalamount;
						echo $symbol.call_user_func_array('number_format', array_merge(array($subtotalamount, 2), $format));
					} else {
						echo "price unavailable";
					}
					?>
				</td>
			</tr>
			
			<?php
		}
		?>

	</table>
	
	<?php
	if ($count == 0) {
		echo "<br /><br /><center><b>".get_option('amzn-onsitecart_empty')."</b></center><br /><br />";								
	}
	?>
		
	<div class='amzncart_priceline'>
		<span class='amzncart_priceline_total'><?php echo get_option('amzn-onsitecart_total'); ?>:</span>
		<span class='amzncart_priceline_totalamount'>
			<?php foreach ($totalamounts as $sym => $amnt): ?>
				<?php echo $sym.call_user_func_array('number_format', array_merge(array($amnt, 2), $totalformats[$sym])) ?><br />
			<?php endforeach ?>
		</span>
	</div>
	
	<div class='amzncart_buttons'>
		<a href='#' id='amzncart_continueshopping' class='amzn_cart_contcheck_link'><?php echo get_option('amzn-onsitecart_continueshopping'); ?></a>
		
		<?php
		if ($count != 0) {
			?>
			<a href='#' id='amzncart_checkout' class='amzn_cart_contcheck_link'><?php echo get_option('amzn-onsitecart_checkout'); ?></a>
			<?php
		}
		?>
		
	</div>
	
	</div>

	<?php
	amzn_onsitecart_form('amzn_onsitecart_form', $cartcontents);
	?>

	<div class='amzncart_price_disclaimer'>
		<?php echo get_option('amzn-onsitecart_pricedisclaimer'); ?>
	</div>
	
	<script>
	
		jQuery(".amzn_cart_contcheck_link").click(function (e) {
			e.preventDefault();
		});	

		jQuery("#amzncart_continueshopping").click(function (e) {
			jQuery("#amzncartdiv").dialog("close");
		});	

		jQuery("#amzncart_checkout").click(function (e) {
			jQuery("#amzn_onsitecart_form").submit();
		});	

	</script>
	
	<?php
	die();
}


function amzn_onsitecart_form($formid, $cartcontents) {
	
	$countrydomain = amzn_cart_domain();
	?>
	
	<form method="GET" action="http://www.amazon<?php echo $countrydomain; ?>/gp/aws/cart/add.html" id='<?php echo $formid; ?>'>
	<input type="hidden" name="AssociateTag" value="<?php echo AWS_ASSOC_ID; ?>"/>
	<input type="hidden" name="SubscriptionId" value="<?php echo AWS_KEY; ?>"/>
	
	<?php
	$count = 0;
	
	foreach ($cartcontents as $postid => $qty) {
		
		if (!$postid) continue;
		if (!get_post_meta($postid, "amzn_ASIN", true)) continue;
	
		$count++;
		
		echo '<input type="hidden" name="ASIN.'.$count.'" value="'.get_post_meta($postid, "amzn_ASIN", true).'"/>';
		echo '<input type="hidden" name="Quantity.'.$count.'" value="'.$qty.'"/>';
	
	}
	?>
	
	</form>
	
	<?php
}


// ONSITE CART WIDGET

function amzn_display_onsitecart($args) {

	if (get_option('amzn-onsitecart') == 'Yes') {


		$ShoppingCart = new CookieShoppingCart();
		$cartcontents = $ShoppingCart->getCart(true);

		$totalcount = 0;

		foreach ($cartcontents as $postid => $qty) {

			if (!$postid) continue;
			if (!get_post_meta($postid, "amzn_ASIN", true)) continue;

			$totalcount++;

		}

		global $wpdb;

		extract($args);

		echo $before_widget;
		echo "<center><span id='amzn_incarttext'>".str_replace("%%", $totalcount, get_option("amzn-onsitecart_currentlyx"))."</span>";
		echo "<br />";
		echo "<a href='#' id='amzncart_widget_viewcart'>".get_option('amzn-onsitecart_viewcart')."</a>";
		
		if ($totalcount != 0) {
			echo "<a href='#' id='amzncart_widget_checkout'>".get_option('amzn-onsitecart_checkout')."</a>";
		}
		
		echo "</center>";

		echo '<div style="display: none;" id="amzn_onsitecart_form_widget_div">';

		amzn_onsitecart_form('amzn_onsitecart_form_widget', $cartcontents);

		echo '</div>';

		?>

		<script>

			jQuery("#amzncart_widget_checkout").button();
			jQuery("#amzncart_widget_viewcart").button();

			jQuery("#amzncart_widget_viewcart").click(function (e) {
				e.preventDefault();
				amzn_onsitecartShow();
			});

			jQuery("#amzncart_widget_checkout").click(function (e) {
				e.preventDefault();

				jQuery("#amzn_onsitecart_form_widget").submit();

			});

			jQuery("#amzncart_widget_checkout2").click(function (e) {
				e.preventDefault();

				jQuery.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>", 
					type:'POST',
					data:'action=amzn_onsitecart_formaj',

					success:function(results) {

						jQuery("#amzn_onsitecart_form_widget_div").html(results);
						jQuery("#amzn_onsitecart_form_widget").submit();

					}

				});

			});

		</script>

		<?php
		isset($abouttext) and print $abouttext;
		isset($after_widget) and print $after_widget;
		
	} else {
		echo "WP Zon Builder error: you must enable On-Site Cart functionality on the WP Zon Builder -> General Settings page under the Buttons & On-Site Cart section to use this widget.";
	}

}


function amzn_display_onsitecart_control() {

	?>

	<div>	
		Display a View Cart and Checkout button. You must enable On-Site Cart functionality on the WP Zon Builder -> General Settings page first.
	</div>

	<?php
}

function init_amzn_display_onsitecart() {
	wp_register_sidebar_widget('amzn_widget_onsitecart', 'WPZonBuilder On-Site Cart', 'amzn_display_onsitecart');
    wp_register_widget_control('amzn_widget_onsitecart', 'WPZonBuilder On-Site Cart', 'amzn_display_onsitecart_control');
}

add_action('init', 'init_amzn_display_onsitecart');

// ----------------------------------------------------

