<?php

function amzn_move_id_to_end($string) {
	$spaced_string = ' ' . $string;
	preg_match_all('/(\s[A-Z\.]*[0-9][A-Z\.]*[0-9][A-Z\.]*[0-9][A-Z0-9\.]*)/', $spaced_string, $matches, PREG_OFFSET_CAPTURE);

	$newstring = "";
	$offset = 0;
	foreach ($matches[1] as $match) {
		$len = strlen($match[0]);
		if ($spaced_string[$match[1]+$len] == ' ') {
			$newstring .= substr($string, $offset, $match[1]-1-$offset);
			$offset = $match[1] - 1 + $len;
		}
	}

	$newstring .= substr($string, $offset);

	foreach ($matches[1] as $match) {
		if ($spaced_string[$match[1]+strlen($match[0])] == ' ')
		$newstring .= $match[0];
	}

	return $newstring;
}


function amzn_add_product_post_formsubmit($product, $aaws) {

	set_time_limit(0);

	// GET CATEGORY
	$post_category = amzn_read_post("singlecat");
	$multiplecategories = amzn_read_post('multiplecategories');


	// GET POST STATUS
	$post_status = amzn_read_post("poststatus");


	// GET PING/COMMENT STATUS
	if (amzn_read_post("allowcomments") == "Yes") {
		$comment_status = "open";
	} else {
		$comment_status = "closed";
	}

	if (amzn_read_post("allowpings") == "Yes") {
		$ping_status = "open";
	} else {
		$ping_status = "closed";
	}

	// GET THE DATE
	if ($_POST["datetype"] == "singledate") {

		// get single date
		$timestamp = strtotime($_POST["singledate"]);
		$post_timestamp = $timestamp;

		if ($timestamp < 1) {
			die("<p>Invalid date provided. Please use a date later than January 1st, 1970 and one that is compatible with <a href='http://www.php.net/strtotime' target='_blank'>strtotime</a>.</p>");
		}

	} else if ($_POST["datetype"] == "randomdate") { // we are using random dates

		$randlow = strtotime($_POST["firstdate"]);
		$randhigh = strtotime($_POST["lastdate"]);

		if ($randlow < 1 || $randhigh < 1) {
			die("<p>Invalid date provided. Please use a date later than January 1st, 1970 and one that is compatible with <a href='http://www.php.net/strtotime' target='_blank'>strtotime</a>.</p>");
		}

		$post_timestamp = rand($randlow, $randhigh);

	}



	// ADD THE POST
	$my_post['post_title'] = $product['title'];


	// spin post title
	if (get_option("amzn-numerictoend") == "Yes") {

		$my_post['post_title'] = amzn_move_id_to_end($my_post['post_title']);

	}
	// ---------
	
	// chop post title
	if (get_option("amzn-ptmaxlength") != null) {
		if (get_option("amzn-ptmaxlength") > 1) {
			$posttitlemax = get_option("amzn-ptmaxlength");

			if ( strlen($my_post['post_title']) > $posttitlemax ) {
				$my_post['post_title'] = preg_replace("/^(.{1,".$posttitlemax."})(\s.*|$)/s", '\\1...', $my_post['post_title'] );
			}


		}
	}
	// ----------

	$my_post['post_content'] = "[amzn_product_post asin='".$product['asin']."']";
	$my_post['post_excerpt'] = "[amzn_product_post_excerpt asin='".$product['asin']."']";

	$my_post['post_content'] = "[amzn_product_post]";
	$my_post['post_excerpt'] = "";


	$my_post['post_status'] = $post_status;
	$my_post['comment_status'] = $comment_status;
	$my_post['ping_status'] = $ping_status;

	if ($post_category != '-1') {
		$my_post['post_category'] = array($post_category);
	}

	if ($multiplecategories != '') {
		$my_post['post_category'] = explode(",", $multiplecategories);
	}

	$my_post['post_date'] = date("Y-m-d H:i:s", $post_timestamp);

	$postuser = amzn_read_request("user");
	if ($postuser != "") {
		$my_post['post_author'] = $postuser;
	}

	if (amzn_read_request("postpages") == "Yes") {
		$my_post['post_type'] = 'page';
		$my_post['post_parent'] = amzn_read_request("parentid");
	}

	$postid = wp_insert_post($my_post);

	// GET POST DATA FROM AMAZON

	$ASIN = $product['asin'];

	$product_data = amzn_get_product_data($ASIN, $aaws);
	extract($product_data);

	amzn_product_to_meta($postid, $product_data);


	// ------------------------
	// ------------------------
	// ------------------------
	// ------------------------
	if (get_option("amzn-localthumbs") == "Yes") {
		if ($LargeImageURL) {
			newpref_generate_post_thumb($LargeImageURL, $postid);
		} else if ( ! $LargeImageURL) {
			if ($MediumImageURL) {
				newpref_generate_post_thumb($MediumImageURL, $postid);
			} else if ( ! $MediumImageURL) {
				newpref_generate_post_thumb($SmallImageURL, $postid);
			}
		}
	}
	// ------------------------
	// ------------------------
	// ------------------------
	

	// TAGS

	$minimum_length = get_option("amzn-tags_length");
	$tagsfilter = get_option('amzn-tags_filter');
	$tagsfilter = explode(",", $tagsfilter);
	
	$my_post['tags_input'] = NULL;

	if (get_option("amzn-tags_posts") == "Yes" || get_option("amzn-tags_title") == "Yes") {

		if (get_option("amzn-tags_posts") != "Yes") {
			$Tags = null;
		}

		if (get_option("amzn-tags_title") == "Yes") {
			$tagsfromtitle = explode(" ", $my_post['post_title']);

			foreach ($tagsfromtitle as $tag) {
				$Tags[] = $tag;
			}
		}

		if ($Tags != null) {
			foreach ($Tags as $t) {
				if (strlen($t) >= $minimum_length) {
					$matched = false;
					foreach ($tagsfilter as $tfilter) {
						if (strtolower(trim($t)) == strtolower(trim($tfilter))) {
							$matched = true;
						}
					}

					if ($matched == false) {
						$realtags[] = $t;
					}
				}
			}

			if ($realtags != null) {
				$my_post['ID'] = $postid;
				$my_post['tags_input'] = implode(",", $realtags);
				wp_update_post($my_post);
			}

		}

	}

	if (amzn_read_request("posttags") != "") {
		$my_post['ID'] = $postid;
		$my_post['tags_input'] = $my_post['tags_input'].",".amzn_read_request("posttags");
		wp_update_post($my_post);				
	}

	$beforepost		= amzn_read_request("amzn-integration_before");
	$afterpost		= amzn_read_request("amzn-integration_after");

	$tagsnocommas = str_replace(",", " ", $my_post['tags_input']);
	$tags = $my_post['tags_input'];
	$ptitle = $product['title'];

	$beforepost = str_replace("%tags%", $tags, $beforepost);
	$beforepost = str_replace("%tagsnocommas%", $tagsnocommas, $beforepost);
	$beforepost = str_replace("%title%", $ptitle, $beforepost);
	$beforepost = str_replace("%asin%", $ASIN, $beforepost);

	$afterpost = str_replace("%tags%", $tags, $afterpost);
	$afterpost = str_replace("%tagsnocommas%", $tagsnocommas, $afterpost);
	$afterpost = str_replace("%title%", $ptitle, $afterpost);
	$afterpost = str_replace("%asin%", $ASIN, $afterpost);

	$my_post['ID'] = $postid;
	$my_post['post_content'] = $beforepost.$my_post['post_content'].$afterpost;

	// brand category

	$brandcategory = amzn_read_request("brandcategory");
	if ($brandcategory == 'Yes') {

		$catid = wp_create_category($Manufacturer[0]);

		if ($post_category != '-1') {
			$my_post['post_category'] = array_merge($my_post['post_category'], array($catid) );
		} else {
			$my_post['post_category'] = array($catid);
			$my_post['post_category'] = array_merge($my_post['post_category'], explode(",", $multiplecategories) );
		}

		if ($post_category == '-1' && $multiplecategories == '' && $brandcategory == 'Yes') {
			$my_post['post_category'] = array($catid);
		}

	}

	// -----------------------
	
	// manual post_excerpt from product description
	
	if (get_option('amzn-excerpts-populatemanual') == 'Yes') {
		
		$postexc = $product_data['ProductDescription'];

		if (get_option('amzn-pd_striptags') == 'Yes' && get_option('amzn-pd_striptags_retroactive') != 'Yes' ) {		
			$postexc = strip_tags ( (string) $postexc );
		}
		
		$my_post['post_excerpt'] = $postexc;
	}
	
	// -------------------------------------------
	
	
	// custom field mapping override content and excerpt

	$mapto = get_option("amzn-integration_mapto");
	$mapto = trim($mapto);
	$mapto = explode("\n", $mapto);
	
	$fieldnames = get_option("amzn-integration_fieldname");
	$fieldnames = trim($fieldnames);
	$fieldnames = explode("\n", $fieldnames);

	foreach ($mapto as $key => $m) {

		$m = trim($m);

		$pdkey = $fieldnames[$key];
		$pdkey = str_replace("amzn_", "", $pdkey);
		$pdkey = trim($pdkey);
		
		$val = NULL;
		isset($product_data[$pdkey])
			and $val = $product_data[$pdkey];
		
		if ($m == "POSTEXCERPT") {
			$my_post['post_excerpt'] = $val;			
		}
		
		if ($m == "POSTCONTENT") {			
			$my_post['post_content'] = $val;			
		}

	}
	
	// ------------------------------

	wp_update_post($my_post);

	$permalink = get_permalink($postid);
	?>

	<div style='background-color: #FFF; margin: 5px; padding: 4px; border: 1px dashed #AAA;'>
		<div style='float: left; width: 500px;'>Posted <a href='<?php echo $permalink; ?>' target='_blank'><b><?php echo $ptitle; ?></b></a></div>
		<div style='float: right; font-weight: bold; color: #00AA00;'>continuing...</div>
		<br clear='all' />
	</div>

	<?php
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";
	echo "                                                                                                                  ";


	flush();
	ob_flush();

	// should not die, this is only here to stop the queue from being cleared while testing
	// die();

}


function amzn_post_products() {

	amzn_enterkeys();

	$url_to_here = str_replace( '%7E', '~', $_SERVER['REQUEST_URI']);
	$url_to_here = explode("&", $url_to_here);
	$url_to_here = $url_to_here[0];

	$products = get_option("amzn_queue_products");

	if ($products == null) {
		echo '<div class="wrap"><h2>Post Products</h2>';
		echo '<div id="error" class="error fade"><p>There are no products in the queue. Go to WPZonBuilder -> Add To Queue first.</p></div>';
		echo '</div>';
		return;
	}

    if (amzn_read_request('formsubmit') == 'Y') {

		echo "<br /><br />";

		$aaws = new AmazonAAWS();

		$count = 0;
		foreach ($products as $product) {
			if (amzn_read_request('preventduplicates') == 'Yes') {
				if ( amzn_alreadyposted($product['asin']) ) {
					?>

					<div style='background-color: #FFF; margin: 5px; padding: 4px; border: 1px dashed #AAA;'>
						<div style='float: left; width: 500px;'><b><?php echo $ptitle; ?> detected as <span style='color: #AA0000;'>duplicate</span></b></div>
						<div style='float: right; font-weight: bold; color: #00AA00;'>continuing...</div>
						<br clear='all' />
					</div>

					<?php
					continue;
				}
			}

			amzn_addtodupes($product['asin']);

			amzn_add_product_post_formsubmit($product, $aaws);
			$count++;
		}

		echo '<br /><div id="message" class="updated fade" style="margin: 4px; padding: 8px; text-align: center;"><p><b>'.$count.' posts have been added.</b></p></div>';

		update_option("amzn_queue_products", null);

		return;
	}
	?>

	<div class="wrap">
		<h2>Post Products</h2>
		<p>
			Using this form, you can post queued products to your website.
		</p>
		<p>
			<i>There are currently <?php echo count($products); ?> products in the queue. You can view and manage the current queue on the Add To Queue page.</i>
		</p>
		
		<form name="form1" method="post" action="<?php echo $url_to_here; ?>">
		
			<b>Category</b>
			
			<small><a href='edit-tags.php?taxonomy=category'>(Add A Category)</a></small><br />
		
			<?php wp_dropdown_categories(array("hide_empty" => 0, "name" => "singlecat", "show_option_none" => "No Category")); ?>
		
			<b>-or-</b><br />
		
			<b>Multiple Categories</b><br />
			<input type='text' name='multiplecategories' /><br />
			<small>(Enter category IDs, separated by commas. If you enter multiple category IDs in this box, make sure the above dropdown is set to No Category or you will receive unpredictable results.)</small>
			<br /><br />
		
			<input type="checkbox" name="brandcategory" id="brandcategory" value="Yes" /> <label onclick="selectradiololz('brandcategory');">Create product manufacturer/brand category</label><br />
			<small>If Amazon provides information on the product brand/manufacturer, a category with this name will be created if it does not already exist, and the product will be placed in this category (as well as the category selected above, unless set to No Category).</small>
			<br /><br />
		
			<b>Post Tags</b><br />
			<i>Enter tags, separated by commas, to be applied to all created posts. Auto-Tagging can be enabled from the <code>Post Tags</code> section of the <code>General Settings</code> page.</i><br />
			<input type="text" name="posttags" id="posttags" value="" style='width: 400px;' />
			<br /><br />
		
			<b>Post Dates</b><br />
			<i>You can use any date format supported by <a href='http://us2.php.net/strtotime' target='_blank'>strtotime</a>.</i><br />
			<i>Examples: </i><code>February 10th, 2009</code>, <code>-7 weeks</code>, <code>March 10th 2010 4:15 PM</code><br />
			<input type="radio" name="datetype" value="singledate" id='singdate' checked /> <label for="singledate" onclick="selectradiololz('singdate');">All Posts Have A Single Date</label>
			<input type="text" name="singledate" id="singledate" value="now" />
			<br />
			<input type="radio" name="datetype" value="randomdate" id='randdate' /> <label for="firstdate" onclick="selectradiololz('randdate');">Random Dates From</label> <input type="text" id="firstdate" name="firstdate" value="-2 weeks" /> - <input type="text" id="lastdate" name="lastdate" value="now" /><br />
			<br /><br />
			
			<b>User To Post As</b><br />
			<?php wp_dropdown_users(); ?>
			<br /><br />
		
			<input type="checkbox" name="allowcomments" id="allowcomments" value="Yes" checked /> <label onclick="selectradiololz('allowcomments');">Allow Comments</label>
			<br />
			<input type="checkbox" name="allowpings" id="allowpings" value="Yes" checked /> <label onclick="selectradiololz('allowpings');">Allow Pings/Trackbacks</label>
			<br /><br />
		
			<b>Post Status</b><br />
			<select name='poststatus'>
				<option value='publish'>Publish</option>
				<option value='pending'>Pending</option>
				<option value='draft'>Draft</option>
			</select>
			<br /><br />
		
			<div style='border: 1px solid #AAA; background-color: #EEE; padding: 8px; margin: 2px;'>
		
				<b><a href='javascript:integrationmjoexpand();'>Integration With 3rd Party Plugins</a></b>
		
				<div id='integrationmjo' style='display: none;'>
		
					<br />
		
					Before Post<br />
					<textarea rows='4' cols='70' name='amzn-integration_before'><?php echo get_option('amzn-integration_before'); ?></textarea><br /><br />
		
					After Post<br />
					<textarea rows='4' cols='70' name='amzn-integration_after'><?php echo get_option('amzn-integration_after'); ?></textarea><br /><br />
		
					<div style='background-color: #FFF; padding: 4px; margin: 2px;'>Instructions, defaults, and available template tags for the Integration With 3rd Party Plugins section can be found on the <i>WPZonBuilder -> Integration</i> page. You must read it if you wish to integrate with 3rd party plugins.</div>
				</div>
		
				<script>
				function integrationmjoexpand() {
					imj = document.getElementById('integrationmjo');
		
					if (imj.style.display != 'none') {
						imj.style.display = 'none';
					} else {
						imj.style.display = 'block';
					}
				}
				</script>
		
			</div>
		
			<br />
			<b>Create Pages</b>
			<br />
			<input type="checkbox" name="postpages" id="postpages" value="Yes" />
			<label onclick="selectradiololz('postpages');">Create Pages, not Posts.</label><br />
		
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<small>Parent Page ID </small><input type="text" name="parentid" id="parentid" value="" />
			<br /><br />
			
			<b>Duplicates</b>
			<br />
			<input type="checkbox" name="preventduplicates" id="preventduplicates" value="Yes" />
			<label onclick="selectradiololz('preventduplicates');">Prevent duplicate products from being posted.</label><br />
			<small>This will prevent products with the same ASIN as products already on your blog from being posted.</small>
			<br /><br />
		
			<script type="text/javascript" src="http://www.google.com/jsapi"></script>
			<script>
			google.load("jqueryui", "1.8.2");
			</script>
		
			<script type="text/javascript">
			jQuery(function() {
				jQuery("input:submit").button();
		
			});
			</script>
		
			<link rel='stylesheet' href='http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css' type='text/css' />
			<input type="hidden" name="formsubmit" value="Y">
			<center>
				<input type="submit" style='margin: 20px; width: 450px; font-size: 24px; height: 70px;' name="Submit" value="Click Here To Post Products" />
			</center>

		</form>

	</div>

	<?php

}
