<?php

function update_post_meta_cache($a, $fieldname, $c, $blacklist) {
	
	if ($blacklist == "false") {
		update_post_meta($a, $fieldname, $c);		
		return;
	}
		
	if ($blacklist != "false") {
		$updatefield = true;
	
		foreach ($blacklist as $nofield) {
			if (trim($fieldname) == trim($nofield)) {
				$updatefield = false;
			}
		}
		
		if ($updatefield == true) {
			update_post_meta($a, $fieldname, $c);
		}
	}
}


function amzn_product_title_from_asin($asin, $aaws) {

	$ASIN = $asin;

	$opt = null;
	$opt['ResponseGroup'] = "ItemAttributes";

	$response = $aaws->item_lookup($ASIN, $opt, WPZonBuilder_LOCALE);

	if ($response->body->Items == null) {
		echo WPZonBuilder_WEBSERVICEERROR;
	}

	$Title = NULL;
	isset($response->body->Items->Item->ItemAttributes->Title)
		and	$Title = $response->body->Items->Item->ItemAttributes->Title;

	return (string) $Title;
}


function amzn_get_product_data($asin, $aaws, $simplesimple = false) {

	$ASIN = $asin;

	$opt = null;
	$opt['ResponseGroup'] = "Images,EditorialReview,ItemAttributes,Reviews,OfferSummary,Offers,Similarities,Accessories,VariationSummary";
	if ($simplesimple == true) {
		$opt['ResponseGroup'] = "Images,ItemAttributes,Reviews,OfferSummary";
	}

	$response = $aaws->item_lookup($ASIN, $opt, WPZonBuilder_LOCALE);

	$opt['OverrideVersion'] = null;

	if ($response->body->Items == null) {
		echo WPZonBuilder_WEBSERVICEERROR;
	}

	$DetailPageURL = NULL;
	isset($response->body->Items->Item->DetailPageURL)
		and $DetailPageURL = $response->body->Items->Item->DetailPageURL;
	
	$Title = NULL;
	isset($response->body->Items->Item->ItemAttributes->Title)
		and $Title = $response->body->Items->Item->ItemAttributes->Title;

	$SmallImageURL = NULL;
	isset($response->body->Items->Item->SmallImage->URL)
		and $SmallImageURL = $response->body->Items->Item->SmallImage->URL;
	
	// [images]
	$MediumImageURL = NULL;
	isset($response->body->Items->Item->MediumImage->URL)
		and $MediumImageURL = $response->body->Items->Item->MediumImage->URL;
	
	$LargeImageURL = NULL;
	isset($response->body->Items->Item->LargeImage->URL)
		and $LargeImageURL = $response->body->Items->Item->LargeImage->URL;

	$ImageSet = NULL;
	if (isset($response->body->Items->Item->ImageSets->ImageSet[0])) {
		$ImageSet = $response->body->Items->Item->ImageSets->ImageSet[0];
	
		if ($SmallImageURL == '') {
			$SmallImageURL = $ImageSet->SmallImage->URL;
		}
		if ($MediumImageURL == '') {
			$MediumImageURL = $ImageSet->MediumImage->URL;
		}
		if ($LargeImageURL == '') {
			$LargeImageURL = $ImageSet->LargeImage->URL;
		}
	}
	// [/images]
	
	// [reviews]
	$ProductDescription = NULL;
	$aeiseopack_description = NULL;
	$EditorialReview = NULL;
	
	if (isset($response->body->Items->Item->EditorialReviews->EditorialReview)) {
		// this is an array. index 0 should be the Product Description, index 1 should be the Amazon.com Product Description
		$EditorialReview = $response->body->Items->Item->EditorialReviews->EditorialReview;
	
		// use ANYTHING
		$ProductDescription = $EditorialReview[0]->Content; // Product Description
		$aeiseopack_description = $EditorialReview[0]->Content; // Product Description
	
		if (get_option('amzn-pd_useeditreview') == "Yes") {	// if editorial review is available, use it.
			if ($EditorialReview != null) {
				foreach ($EditorialReview as $ed) {
					if ($ed->Source == 'Editorial Review') {
						$ProductDescription = $ed->Content;
					}
					/*
					// use product descriptions
					if ($ed->Source == 'Product Description') {
						$ProductDescription = $ed->Content;
					}
					*/
				}
			}
		}
	}
	// [/reviews]

	// This is an array. This will not be set for a product with no features. At least we hope. (update: confirmed. serializing this spits out N; or something, which is null.)
	$Features = null;
	if (isset($response->body->Items->Item->ItemAttributes->Feature)) {
		foreach ($response->body->Items->Item->ItemAttributes->Feature as $f) {
			$Features[] = (string) $f;
		}
	}

	$Manufacturer = NULL;
	isset($response->body->Items->Item->ItemAttributes->Manufacturer)
		and $Manufacturer = $response->body->Items->Item->ItemAttributes->Manufacturer;
	
	// [price]
	$ListPrice = NULL;
	isset($response->body->Items->Item->ItemAttributes->ListPrice->FormattedPrice)
		and $ListPrice = $response->body->Items->Item->ItemAttributes->ListPrice->FormattedPrice;
	
	if ($ListPrice == null) {
		isset($response->body->Items->Item->VariationSummary->HighestPrice->FormattedPrice)
			and $ListPrice = $response->body->Items->Item->VariationSummary->HighestPrice->FormattedPrice;
	}
	
	if (get_option("amzn-oldstyleprice") == "Yes") {
		$LowestNewPrice = NULL;
		isset($response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice)
			and $LowestNewPrice = $response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice; // 1.0-1.16b style price
	} else {
		$LowestNewPrice = NULL;
		isset($response->body->Items->Item->Offers->Offer->OfferListing->Price->FormattedPrice)
			and $LowestNewPrice = $response->body->Items->Item->Offers->Offer->OfferListing->Price->FormattedPrice; // 2.0 style price
	}
	
	// 2.2 better prices
	
	// get sale price from used or other sources if new not available	
	if ($LowestNewPrice == null and isset($response->body->Items->Item->OfferSummary->LowestUsedPrice->FormattedPrice)) {
		$LowestNewPrice = $response->body->Items->Item->OfferSummary->LowestUsedPrice->FormattedPrice;
	}
	if ($LowestNewPrice == null and isset($response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice)) {
		$LowestNewPrice = $response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice;
	}
	if ($LowestNewPrice == null and isset($response->body->Items->Item->VariationSummary->LowestSalePrice->FormattedPrice)) {
		$LowestNewPrice = $response->body->Items->Item->VariationSummary->LowestSalePrice->FormattedPrice;
	}
	if ($LowestNewPrice == null and isset($response->body->Items->Item->VariationSummary->LowestPrice->FormattedPrice)) {
		$LowestNewPrice = $response->body->Items->Item->VariationSummary->LowestPrice->FormattedPrice;
	}
	//  -----------------

	// [/price]
	
	$Availability = NULL;
	isset($response->body->Items->Item->Offers->Offer->OfferListing->Availability)
		and $Availability = $response->body->Items->Item->Offers->Offer->OfferListing->Availability;
	
	$IsEligibleForSuperSaverShipping = NULL;
	isset($response->body->Items->Item->Offers->Offer->OfferListing->IsEligibleForSuperSaverShipping)
		and $IsEligibleForSuperSaverShipping = $response->body->Items->Item->Offers->Offer->OfferListing->IsEligibleForSuperSaverShipping;
	
	$AllCustomerReviewsURL = NULL;
	$TellAFriendURL = NULL;
	// This is an array. This will not be set for a product with no item links. At least we hope.
	if (isset($response->body->Items->Item->ItemLinks->ItemLink)) {
		foreach ($response->body->Items->Item->ItemLinks->ItemLink as $il) {
			if ($il->Description == "All Customer Reviews") {
				$AllCustomerReviewsURL = $il->URL;
			}
			if ($il->Description == "Tell A Friend") {
				$TellAFriendURL = $il->URL;
			}
		}
	}

	$Accessories = NULL;
	if (isset($response->body->Items->Item->Accessories->Accessory)) {
		$Accessories = array();
		foreach ($response->body->Items->Item->Accessories->Accessory as $f) {
			$Accessories[] = array("ASIN" => (string) $f->ASIN, "Title" => (string) $f->Title);
		}
	}

	$SimilarProducts = NULL;
	if (isset($response->body->Items->Item->SimilarProducts->SimilarProduct)) {
		$SimilarProducts = array();
		foreach ($response->body->Items->Item->SimilarProducts->SimilarProduct as $f) {
			$SimilarProducts[] = array("ASIN" => (string) $f->ASIN, "Title" => (string) $f->Title);
		}
	}
	
	// [stubs] These properties cannot be found in results from Amazon any more...
	$Tags = null;
	$AverageRating = NULL;
	$TotalReviews = NULL;
	// [/stubs]
	
	
	// ------------ get the rating with XPath 2.4
	if (get_option('amzn-apiratinganyway') == 'Yes') {
		$IFrameURL = NULL;
		isset($response->body->Items->Item->CustomerReviews->IFrameURL)
			and $IFrameURL = $response->body->Items->Item->CustomerReviews->IFrameURL;
		
		if ($IFrameURL) {
			$ratingreviews = amzn_xpath_get_rating_reviews($IFrameURL);
			
			$AverageRating = $ratingreviews['AverageRating'];
			$TotalReviews = $ratingreviews['TotalReviews'];
		}
	}
	// -------------

	$data['Accessories'] 						= $Accessories;
	$data['SimilarProducts'] 					= $SimilarProducts;

	$data['Title']								= $Title;
	$data['ASIN']								= $ASIN;
	$data['DetailPageURL']						= $DetailPageURL;
	$data['SmallImageURL']						= $SmallImageURL;
	$data['MediumImageURL']						= $MediumImageURL;
	$data['LargeImageURL']						= $LargeImageURL;
	$data['ProductDescription']					= $ProductDescription;
	$data['Features_serialize']					= serialize($Features); // Features is an array
	$data['Features']							= $Features; // Features is an array
	$data['AverageRating']						= $AverageRating;
	$data['TotalReviews']						= $TotalReviews;
	$data['Manufacturer']						= $Manufacturer;
	$data['ListPrice']							= $ListPrice;
	$data['LowestNewPrice']						= $LowestNewPrice;
	$data['Availability']						= $Availability;
	$data['AllCustomerReviewsURL']				= $AllCustomerReviewsURL;
	$data['TellAFriendURL']						= $TellAFriendURL;
	$data['IsEligibleForSuperSaverShipping']	= $IsEligibleForSuperSaverShipping;
	$data['aeiseopack_description']				= $aeiseopack_description;

	$data['Tags'] 								= $Tags;

	// image sets
	
	$ImageSets = NULL;
	isset($response->body->Items->Item->ImageSets) 
		and $ImageSets = $response->body->Items->Item->ImageSets;

	$data['ImageSets_serialize'] = serialize(amzn_objectsIntoArray($ImageSets)); // $ImageSet is an array/XML object

	return $data;
}


function amzn_product_to_meta($postid, $product_data, $cache = false) {
	
	// cache data expiry blacklist
	
	if ($cache == true) {
		$blacklist = trim(get_option("amzn-dataexpiry_blacklist"));
		
		if ($blacklist == "") {
			$blacklist = "false";
		} else {
			$blacklist = explode("\n", $blacklist);
		}
		
	} else {
		$blacklist = "false";
	}

	extract($product_data);

	if (get_option('amzn-aioseop') == 'Yes') {

		if (is_array($Tags)) {
			update_post_meta_cache($postid, '_aioseop_keywords', (string) implode(",", $Tags), $blacklist);
		}

		update_post_meta_cache($postid, '_aioseop_title', (string) $Title, $blacklist);
		update_post_meta_cache($postid, '_aioseop_description', (string) $aeiseopack_description, $blacklist);

	}

	// image sets
	update_post_meta_cache($postid, 'amzn_ImageSets_serialize',  $ImageSets_serialize, $blacklist);
	// -------

	update_post_meta_cache($postid, 'amzn_Accessories_serialize',  serialize($Accessories), $blacklist);
	update_post_meta_cache($postid, 'amzn_SimilarProducts_serialize',  serialize($SimilarProducts), $blacklist);

	update_post_meta_cache($postid, 'amzn_Title', (string) $Title, $blacklist);
	update_post_meta_cache($postid, 'amzn_ASIN', (string) $ASIN, $blacklist);
	update_post_meta_cache($postid, 'amzn_DetailPageURL', (string) $DetailPageURL, $blacklist);
	update_post_meta_cache($postid, 'amzn_SmallImageURL', (string) $SmallImageURL, $blacklist);
	update_post_meta_cache($postid, 'amzn_MediumImageURL', (string) $MediumImageURL, $blacklist);
	update_post_meta_cache($postid, 'amzn_LargeImageURL', (string) $LargeImageURL, $blacklist);
	update_post_meta_cache($postid, 'amzn_Features_serialize', serialize($Features), $blacklist); // Features is an array
	update_post_meta_cache($postid, 'amzn_AverageRating', (string) $AverageRating, $blacklist);
	update_post_meta_cache($postid, 'amzn_TotalReviews', (string) $TotalReviews, $blacklist);
	update_post_meta_cache($postid, 'amzn_Manufacturer', (string) $Manufacturer, $blacklist);
	update_post_meta_cache($postid, 'amzn_ListPrice', (string) $ListPrice, $blacklist);
	update_post_meta_cache($postid, 'amzn_LowestNewPrice', (string) $LowestNewPrice, $blacklist);
	update_post_meta_cache($postid, 'amzn_Availability', (string) $Availability, $blacklist);
	update_post_meta_cache($postid, 'amzn_IsEligibleForSuperSaverShipping', (string) $IsEligibleForSuperSaverShipping, $blacklist);
	update_post_meta_cache($postid, 'amzn_AllCustomerReviewsURL', (string) $AllCustomerReviewsURL, $blacklist);
	update_post_meta_cache($postid, 'amzn_TellAFriendURL', (string) $TellAFriendURL, $blacklist);
	
	// non-retromode HTML stripping
	
	if (get_option('amzn-pd_striptags') == 'Yes' && get_option('amzn-pd_striptags_retroactive') != 'Yes' ) {		
		update_post_meta_cache($postid, 'amzn_ProductDescription', strip_tags ( (string) $ProductDescription ) , $blacklist);
	} else {
		update_post_meta_cache($postid, 'amzn_ProductDescription', (string) $ProductDescription, $blacklist);
	}

	// Data expiry

	update_post_meta($postid, "amzn_recency", (string) time());

	// ------------
	
	// Custom Field Mapping

	$mapto = get_option("amzn-integration_mapto");
	$mapto = trim($mapto);
	$mapto = explode("\n", $mapto);
	
	$fieldnames = get_option("amzn-integration_fieldname");
	$fieldnames = trim($fieldnames);
	$fieldnames = explode("\n", $fieldnames);

	foreach ($mapto as $key => $m) {

		$m = trim($m);

		$pdkey = $fieldnames[$key];
		$pdkey = str_replace("amzn_", "", $pdkey);
		$pdkey = trim($pdkey);

		$val = NULL;
		isset($product_data[$pdkey])
			and $val = $product_data[$pdkey];

		update_post_meta_cache($postid, $m, (string) $val, $blacklist);

//		echo $m;
//		echo " IS NOW ";
//		echo $pdkey;
//		echo " which has value of ";
//		echo (string) $product_data[$pdkey];
//		echo "<br /><br />";

	}

}


function amzn_product_from_meta($postid) {

	$data['Title']								= get_post_meta($postid, 'amzn_Title', true);
	$data['ASIN']								= get_post_meta($postid, 'amzn_ASIN', true);
	$data['SmallImageURL']						= get_post_meta($postid, 'amzn_SmallImageURL', true);
	$data['MediumImageURL'] 					= get_post_meta($postid, 'amzn_MediumImageURL', true);
	$data['LargeImageURL'] 						= get_post_meta($postid, 'amzn_LargeImageURL', true);
	$data['ProductDescription'] 				= get_post_meta($postid, 'amzn_ProductDescription', true);
	$data['Features'] 							= unserialize(get_post_meta($postid, 'amzn_Features_serialize', true)); // Features was seralized before being put in the DB
	$data['AverageRating']						= get_post_meta($postid, 'amzn_AverageRating', true);
	$data['TotalReviews']						= get_post_meta($postid, 'amzn_TotalReviews', true);
	$data['Manufacturer']						= get_post_meta($postid, 'amzn_Manufacturer', true);
	$data['ListPrice']							= get_post_meta($postid, 'amzn_ListPrice', true);
	$data['LowestNewPrice']						= get_post_meta($postid, 'amzn_LowestNewPrice', true);
	$data['Availability']						= get_post_meta($postid, 'amzn_Availability', true);
	$data['IsEligibleForSuperSaverShipping']	= get_post_meta($postid, 'amzn_IsEligibleForSuperSaverShipping', true);

	$data['IFrameURL']	= get_post_meta($postid, 'amzn_IFrameURL', true);

	$data['DetailPageURL']						= get_post_meta($postid, 'amzn_DetailPageURL', true);
	$data['AllCustomerReviewsURL']				= get_post_meta($postid, 'amzn_AllCustomerReviewsURL', true);
	$data['TellAFriendURL']						= get_post_meta($postid, 'amzn_TellAFriendURL', true);

	$data['ImageSets']							= unserialize(get_post_meta($postid, 'amzn_ImageSets_serialize', true)); //ImageSets was serialized before being puti n DB

	// retromode HTML stripping
	if (get_option('amzn-pd_striptags') == 'Yes' && get_option('amzn-pd_striptags_retroactive') == 'Yes' ) {		
		$data['ProductDescription'] = strip_tags ( $data['ProductDescription'] );
	}

	return $data;
}
