<?php

// $products = get_option("amzn_queue_products");
// wp_enqueue_script('jquery');

add_action('wp_ajax_amzn_clear_queue', 'amzn_clear_queue');

function amzn_clear_queue() {
	
	$products = null;
	update_option("amzn_queue_products", $products);

	die();
}

add_action('wp_ajax_amzn_view_queue', 'amzn_view_queue');
function amzn_view_queue() {

	$products = get_option("amzn_queue_products");

	if (!is_array($products)) {
		$count = 0;
	} else {
		$count = count($products);
	}

	echo $count." product(s) in the queue. <a href='javascript:amznViewQueue();' class='amznrefreshqueue' >Refresh Queue</a>";
	echo "<div style='height: 150px; overflow: scroll; background-color: #FFF; border: 1px solid #AAA;'>";

	if ($count != 0) {

		foreach ($products as $product) {
			echo "<div style='margin: 4px; padding: 3px; font-weight: bold; background-color: #EEE;'>";
			echo $product['title'];
			echo " - ";

			echo "<a id='".$product['asin']."qlist' href='";

			?>

			javascript:amznRemoveFromQueue("<?php echo $product['asin']; ?>", "<?php echo amzn_js_function_escape($product['title']); ?>");

			<?php
			echo "'>Remove</a>";
			echo "</div>";
		}
	}

	echo "</div>";
	die();
}


add_action('wp_ajax_amzn_add_to_queue_server', 'amzn_add_to_queue_server');
function amzn_add_to_queue_server() {


	// No Amazon Product should ever have \' or \" somewhere in the title. But if they do, this will make things break.
	$product['asin'] = stripslashes($_POST["asin"]);
	$product['title'] = stripslashes($_POST["title"]);

	$products = get_option("amzn_queue_products");

	$products[] = $product; // add to the array, or if $products is null, this will be created as the first element.

	update_option("amzn_queue_products", $products);

	die();

}

add_action('wp_ajax_amzn_add_many_to_queue_server', 'amzn_add_many_to_queue_server');
function amzn_add_many_to_queue_server() {

	//	keyword: keyword,
	//	sortval: sortval,
	//	se: se,
	//	currentpage: currentpage

	$keyword = $_REQUEST["keyword"];
	$sortval = $_REQUEST["sortval"];
	$se = $_REQUEST["se"];
	$currentpage = $_REQUEST["currentpage"];
	$browsenode = $_REQUEST["browsenode"];
	$num = $_REQUEST["num"];

	// echo "Keyword: ".$keyword;
	// echo "\n";
	// echo "Sort Val: ".$sortval;
	// echo "\n";
	// echo "Search Index: ".$se;
	// echo "\n";
	// echo "Current Page: ".$currentpage;
	// echo "\n";
	// echo "Number Of Results ".$num;
	// echo "\n\n\n\n\n";

	if ($num != "") {
		$totalpages = ceil($num/10);
	} else {
		$totalpages = 1;
	}

	// echo "Total Pages To Do".$totalpages;
	// echo "\n\n\n";

	$pagecount = 1;

	while ($pagecount <= $totalpages) {

		// echo "Doing ".$currentpage." right now";
		// echo " which means ".$pagecount.' is $pagecount right now';
		// echo "\n";

		$aaws = new AmazonAAWS();

		if ($currentpage == 0) $currentpage = 1;
		if ($currentpage > 10) $currentpage = 10; // Amazon says max of 10 pages

		if ($keyword == "" && $browsenode == "") {

			echo "<h1>You must enter a keyword or browse node.</h1>";
			return;

		}

		$opt = null;
		$opt['ItemPage'] = $currentpage;
		if ($se != '') {
			$opt['SearchIndex'] = $se;
		}

		if ($sortval != '-') {
			$opt['Sort'] = $sortval;
		}

		if ($browsenode != "") {
			$opt['BrowseNode'] = $browsenode;
		}

		$opt['ResponseGroup'] = "Images,EditorialReview,ItemAttributes,Reviews,OfferSummary,Offers";

		$search = $aaws->item_search($keyword, $opt, WPZonBuilder_LOCALE);

		$TotalResults = NULL;
		isset($search->body->Items->TotalResults)
			and $TotalResults = $search->body->Items->TotalResults;
		
		$TotalPages = NULL;
		isset($search->body->Items->TotalPages)
			and $TotalPages = $search->body->Items->TotalPages;
		if ($TotalPages > 10) $TotalPages = 10; // Amazon says max of 10 pages for now

		// [items]
		$Items = NULL;
		if ( ! isset($search->body->Items->Item)) {
			echo WPZonBuilder_WEBSERVICEERROR;
		} else {
			$Items = $search->body->Items->Item;
			foreach ($Items as $item) {
	
				$ASIN = $item->ASIN;
				
				$Title = NULL;
				isset($item->ItemAttributes->Title)
					and $Title = $item->ItemAttributes->Title;
	
				$SmallImageURL = NULL;
				isset($item->SmallImage->URL)
					and $SmallImageURL = $item->SmallImage->URL;
				
				$Price = NULL;
				isset($item->OfferSummary->LowestNewPrice->FormattedPrice)
					and $Price = $item->OfferSummary->LowestNewPrice->FormattedPrice;
				
				$Availability = NULL;
				isset($item->Offers->Offer->OfferListing->Availability)
					and $Availability = $item->Offers->Offer->OfferListing->Availability;
	
				// [filtering]
				$filtered = false;
	
				if (amzn_read_request("Filter_highprice") != '') {
					$Filter_highprice = floatval(amzn_read_request("Filter_highprice"));
				} else {
					$Filter_highprice = 1.0E+20;
				}
	
				if (amzn_read_request("Filter_lowprice") != '') {
					$Filter_lowprice = floatval(amzn_read_request("Filter_lowprice"));
				} else {
					$Filter_lowprice = 0;
				}
	
				if (amzn_read_request("Filter_hasimage") != '') {
					$Filter_hasimage = true;
				} else {
					$Filter_hasimage = false;
				}
	
				if (amzn_read_request("Filter_noavailabilityinfo") != '') {
					$Filter_noavailabilityinfo = true;
				} else {
					$Filter_noavailabilityinfo = false;
				}
				
				$testpricehere = AmazonAAWS_Locale::price_to_float($Price);			
				if ( $testpricehere < $Filter_lowprice) {
					$filtered = true;
				}
				if ( $testpricehere > $Filter_highprice) {
					$filtered = true;
				}
				if ($Filter_noavailabilityinfo == true && $Availability == '') {
					$filtered = true;
				}
				if ($Filter_hasimage == true && $SmallImageURL == '') {
					$filtered = true;
				}
				if ($filtered == true) {
					continue;
				}
				// [/filtering]
	
				$products[] = array("asin" => $ASIN, "title" => $Title);
	
			}
		}
		// [/items]

		// delete all products with a matching asin from the queue first, so we dont have duplicates

		$dupeproducts = get_option("amzn_queue_products");

		if ($dupeproducts != null) {

			foreach ($products as $product) {

				// No Amazon Product should ever have \' or \" somewhere in the title. But if they do, this will make things break.
				$asin = $product["asin"];

				$dupeproducts = get_option("amzn_queue_products");
				$products2 = $dupeproducts;

				foreach ($products2 as $key => $product) {
					if ($product['asin'] == $asin) {
						$deletekey = $key;
					}
				}

				unset($dupeproducts[$deletekey]);

				update_option("amzn_queue_products", $dupeproducts);

			}

		}

		// now add each product ot the queue

		$aa = 0;

		foreach ($products as $product) {
			$aa++;
			if ($num != "") {
				if ($aa > $num) {
					break;
				}
			}

			$product['asin'] = stripslashes($product["asin"]);
			$product['title'] = stripslashes($product["title"]);

			$productslol = get_option("amzn_queue_products");

			$productslol[] = $product; // add to the array, or if $products is null, this will be created as the first element.

			update_option("amzn_queue_products", $productslol);
		}
		$pagecount++;
		$currentpage++;
	}
	die();
}


add_action('wp_ajax_amzn_remove_from_queue_server', 'amzn_remove_from_queue_server');
function amzn_remove_from_queue_server() {

	// No Amazon Product should ever have \' or \" somewhere in the title. But if they do, this will make things break.
	$asin = stripslashes($_POST["asin"]);
	$product['title'] = stripslashes($_POST["title"]);

	$products = get_option("amzn_queue_products");
	$products2 = $products;

	foreach ($products2 as $key => $product) {
		if ($product['asin'] == $asin) {
			$deletekey = $key;
		}
	}

	unset($products[$deletekey]);
	update_option("amzn_queue_products", $products);
	
	die();
}


add_action('wp_ajax_amzn_asins_to_queue', 'amzn_asins_to_queue');
function amzn_asins_to_queue() {

	$asins = amzn_read_post("asins");
	$asins = explode(",", $asins);
	$products = get_option("amzn_queue_products");
	$aaws = new AmazonAAWS();

	foreach ($asins as $asin) {
		$product['asin'] = $asin;
		$product['title'] = (string) amzn_product_title_from_asin($asin, $aaws);

		if ($product['title'] == '') {
			echo "ASIN '".$asin."' not found!\n\n";
		} else {
			$products[] = $product; // add to the array, or if $products is null, this will be created as the first element.
		}
	}

	update_option("amzn_queue_products", $products);

	die();
}


function amzn_build_search_form() {

	echo "<div style='display: none;'>";
	amzn_output_sort_selects();
	echo "</div>";

	echo "<table width='100%'><tr><td align='left' style='padding-right: 10px; width: 100%;'>";

	echo "Category/SearchIndex</td>";

	echo "<td align='left'>";
	amzn_output_search_form_select("searchindexesselect");
	echo "</td>";

	echo "</tr><tr><td align='left'>";
	echo "Sort Order</td>";

	echo "<td align='left'><select name='sortval' id='sortsel' style='width: 170px;'>";
	echo "<option value='-'>-</option>";
	echo "</select></td>";

	echo "</tr><tr><td align='left'>";

	echo "Keywords</td><td align='left'><input type='text' style='width: 170px;' name='keyword' value='".(isset($_REQUEST['keyword']) ? $_REQUEST['keyword'] : '')."'></td></tr>";

	echo "<tr><td align='left'>Browse Node ID</td><td align='left'><input style='width: 170px;' type='text' name='browsenode' value='".(isset($_REQUEST['browsenode']) ? $_REQUEST['browsenode'] : '')."'></td></tr>";

	echo "</table>";

	echo "<br />";

	?>
	<script>
	jQuery('#catselect').val("<?php echo amzn_read_request('searchindexesselect') ?>").change();
	jQuery('#sortsel').val("<?php echo amzn_read_request('sortval') ?>").change();
	</script>

	<?php

}


function amzn_output_sort_selects() {

	foreach (AmazonAAWS_Locale::search_indexes(WPZonBuilder_LOCALE) as $si) {
		echo "<div id='".$si."div'>";
			$sort_values = AmazonAAWS_Locale::search_sort_values($si, WPZonBuilder_LOCALE);
			echo "<select class='sortselect' id='".$si."' name='unused'>";
				if ($sort_values) {
					foreach (AmazonAAWS_Locale::search_sort_values($si, WPZonBuilder_LOCALE) as $sv) {
						echo "<option value='".$sv."'>".esc_html(AmazonAAWS_Locale::sort_value_title($sv))."</option>";
					}
				} else {
					echo "<option value=''>-</option>";
				}
			echo "</select>";
		echo "</div>";
	}
	
	echo "
	<div id='bongbongbonbgdiv'>
		<select name='unusted' id='bongbongbong'>
		<option value='-'>-</option>
		</select>
	</div>
	";

}


function amzn_output_search_form_select($selectname) {

	echo "<select name='".$selectname."' onchange='updateselect()' id='catselect' style='width: 170px;'>";
		foreach (AmazonAAWS_Locale::search_indexes(WPZonBuilder_LOCALE) as $si) {
			echo "<option value='".$si."'>".esc_html(AmazonAAWS_Locale::search_index_title($si))."</option>";
		}
	echo  "</select>";
}


function amzn_queue_products() {

	amzn_enterkeys();

	$url_to_here = str_replace( '%7E', '~', $_SERVER['REQUEST_URI']);
	$url_to_here = explode("&", $url_to_here);
	$url_to_here = $url_to_here[0];

	if (amzn_read_request('option') == "clearqueue") {
		$products = null;
		update_option("amzn_queue_products", $products);
	}

	$products = get_option("amzn_queue_products");

	?>

	<div class="wrap">
		<div style='float: left; width: 350px;'>

	<script type="text/javascript" src="http://www.google.com/jsapi"></script>
	<script>
	// google.load("jquery", "1.4.2");
	google.load("jqueryui", "1.8.2");
	</script>

	<script type="text/javascript">
	jQuery(function() {
		jQuery("input:submit, input:button").button();

	});
	</script>

	<link rel='stylesheet' href='http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css' type='text/css'>


			<h2>Find Products</h2>

			<form name="form1" method="post" action="<?php echo $url_to_here; ?>" style="padding-right: 25px">

				<?php
				amzn_build_search_form();
				?>

				<b><a href='javascript:void(0);' onclick='jQuery("#filterform").toggle("slow");' >View Filtering Options +</a></b><br />
				<div id='filterform' style='display: none;'>
					<table>
					<tr>
					<td style='text-align: right; padding-right: 10px;'>
						Max. Price
					</td>
					<td>
						<input type='text' style='width: 70px;' name='Filter_highprice' value='<?php echo amzn_read_request("Filter_highprice"); ?>'>
					</td>
					</tr>

					<tr>
					<td style='text-align: right; padding-right: 10px;'>
						Min. Price
					</td>
					<td>
						<input type='text' style='width: 70px;' name='Filter_lowprice' value='<?php echo amzn_read_request("Filter_lowprice"); ?>'>
					</td>
					</tr>

					<tr>
					<td style='text-align: right; padding-right: 10px;'>
						Only show products with images
					</td>
					<td style='text-align: center;'>
						<input type='checkbox' name='Filter_hasimage' <?php if (amzn_read_request("Filter_hasimage")=="on") echo "checked"; ?>>
					</td>
					</tr>


					<tr>
					<td style='text-align: right; padding-right: 10px;'>
						Only show products with availability information
					</td>
					<td style='text-align: center;'>
						<input type='checkbox' name='Filter_noavailabilityinfo'  <?php if (amzn_read_request("Filter_noavailabilityinfo")=="on") echo "checked"; ?>>
					</td>
					</tr>

				</table>

				</div>
				<br />
				<input type="hidden" name="formsubmit" value="Y">
				<center><input type='submit' value='Get Products' style='width: 150px; font-size: 16px; font-weight: bold;'></center>

				<br />

				<b><a href='javascript:void(0);' onclick='jQuery("#howtouse").toggle("slow");' >[?] How To Use This Page +</a></b>

				<div id='howtouse' style='display: none;'>
					<?php include "amznhowtousequeue.php"; ?>
				</div>

			</form>

		</div>

		<div style='float: left; width: 50%;'>
			<h2>Current Queue</h2>
			
			<div id='viewqueue'></div>
			<a class='amznclearqueue' href='javascript:amznClearQueue("<?php echo $url_to_here; ?>&option=clearqueue");'>Clear Queue (no undo)</a>
			<script>amznViewQueue();</script>
			<br /><br />
			
			<?php
			$waitgif = WP_PLUGIN_URL."/amzn/ajax-loader.gif";
			?>
			<a href='javascript:void(0);' onclick='alert("This feature allows you to add many products to the queue with just their ASINs. Enter a list of ASINs you would like to add, separated by commas.")' ><small>[?]</small></a> Enter list of ASINs, separated by commas: <br /><input type='text' style='width: 300px;' id='asinstoqueue' /> <input type='button' onclick='amznAsinsToQueue("<?php echo $waitgif; ?>");' value='Add ASINs to Queue' />
			<div id='waitgifloc' style='padding-left: 16px;'></div>
			<br />
			
		</div>

		<br clear='all' />

		<?php
	    if (amzn_read_request('formsubmit') == 'Y' || isset($_REQUEST["currentpage"])) {

			$sortval = amzn_read_request("sortval");
			$currentpage = intval(amzn_read_request("currentpage"));

			$browsenode = $_REQUEST["browsenode"];

			if ($currentpage < 1) $currentpage = 1;
			if ($currentpage > 10) $currentpage = 10; // Amazon says max of 10 pages

			$keyword = amzn_read_request("keyword");
			$se = amzn_read_request("searchindexesselect");

			$waitgif = WP_PLUGIN_URL."/amzn/ajax-loader.gif"
			?>

			<b style='font-size: 15px;'>Bulk Selection</b>
			<span style='font-size: 9px; position: relative; top: -4px;'><a href='javascript:alert("It is not recommended you add too many products from one search. Amazon returns the most relevant results first. As a general rule, the farther the down the results you go, the less likely it is you are going to get quality products that sell. If you are just trying to build a massive content site, it is fine, but if you want make money from commissions, be careful not to populate your site with products that do not sell well.");'>[?]</a></span>

			<br /><br />

			<div id='pleasewaitdiv'>
				<a id='addallonpage'  class='amznaddlink' href='javascript:amznAllOnPage("<?php echo $keyword; ?>", "<?php echo $sortval; ?>", "<?php echo $se; ?>", "<?php echo $currentpage; ?>", "<?php echo $browsenode; ?>", "<?php echo $url_to_here; ?>&sortval=<?php echo $sortval; ?>&currentpage=<?php echo $currentpage; ?>&keyword=<?php echo $keyword; ?>&searchindexesselect=<?php echo $se; ?>&browsenode=<?php echo $browsenode; ?>", "<?php echo $waitgif; ?>");'>Add All Results On This Page To Queue</a><br />
				<br />
				<a id='addfirstonpage' class='amznaddlink' href='javascript:amznFirstResults("<?php echo $keyword; ?>", "<?php echo $sortval; ?>", "<?php echo $se; ?>", "<?php echo $currentpage; ?>", "<?php echo $browsenode; ?>", "<?php echo $url_to_here; ?>&sortval=<?php echo $sortval; ?>&currentpage=<?php echo $currentpage; ?>&keyword=<?php echo $keyword; ?>&searchindexesselect=<?php echo $se; ?>&browsenode=<?php echo $browsenode; ?>", "<?php echo $waitgif; ?>");'>Add First</a> <input type='text' value='100' id='addfirstnum' /> <a id='addfirstonpage1' class='amznaddlink' href='javascript:amznFirstResults("<?php echo $keyword; ?>", "<?php echo $sortval; ?>", "<?php echo $se; ?>", "<?php echo $currentpage; ?>", "<?php echo $browsenode; ?>", "<?php echo $url_to_here; ?>&sortval=<?php echo $sortval; ?>&currentpage=<?php echo $currentpage; ?>&keyword=<?php echo $keyword; ?>&searchindexesselect=<?php echo $se; ?>&browsenode=<?php echo $browsenode; ?>", "<?php echo $waitgif; ?>");'>Results To Queue</a>
				<br />
				<small>If you have Filtering Options set, you will get fewer products than the number entered in the above text box, because the products that do not match the filtering options will be discarded.</small>
			</div>
			<br />

			<b style='font-size: 15px;'>Individual Selection</b>

			<?php
		}
		?>

	</div>

	<?php
    if (amzn_read_request('formsubmit') == 'Y' || isset($_REQUEST["currentpage"])) {

		$sortval = amzn_read_request("sortval");

		$aaws = new AmazonAAWS();

		$currentpage = intval(amzn_read_request("currentpage"));
		if ($currentpage < 1) $currentpage = 1;
		if ($currentpage > 10) $currentpage = 10; // Amazon says max of 10 pages


		$keyword = amzn_read_request("keyword");
		$se = amzn_read_request("searchindexesselect");

		$browsenode = amzn_read_request("browsenode");

		if ($keyword == "" && $browsenode == "") {
			echo "<h1>You must enter keywords or a browse node.</h1>";
			return;
		}

		$opt = null;
		$opt['ItemPage'] = $currentpage;
		if ($se != '') {
			$opt['SearchIndex'] = $se;
		}
		if ($sortval != '-') {
			$opt['Sort'] = $sortval;
		}
		// browse nodes
		$opt['BrowseNode'] = $browsenode;

		$search = $aaws->item_search($keyword, $opt, WPZonBuilder_LOCALE);

		if (isset($search->body->Items->Request->Errors->Error)) {
			echo "<center style='border: 1px solid #F00; background-color: #FCC;'><h2>Amazon Returned An Error</h2>";
			echo "Below are the error messages and error codes as returned by Amazon.<br /><br />";
			echo "Error Code(s): ";
			echo $search->body->Items->Request->Errors->Error->Code;
			echo "<br />Error Message(s): ";
			echo $search->body->Items->Request->Errors->Error->Message;
			echo "<br /><br /></center>";
		}

		$TotalResults = NULL;
		isset($search->body->Items->TotalResults)
			and $TotalResults = $search->body->Items->TotalResults;
		
		$TotalPages = NULL;
		isset($search->body->Items->TotalPages)
			and $TotalPages = $search->body->Items->TotalPages;
		if ($TotalPages > 10) $TotalPages = 10; // Amazon says max of 10 pages
		if ($opt['SearchIndex'] == 'All') { // Amazon says max of 5 pages for All search index
			$TotalPages = 5;
		}

		$Items = NULL;
		isset($search->body->Items->Item)
			and $Items = $search->body->Items->Item;

		if ($Items == null) {
			echo WPZonBuilder_WEBSERVICEERROR;
		} else {
			
			foreach ($Items as $item) {
	
				$ASIN = $item->ASIN;
				
				$DetailPageURL = NULL;
				isset($item->DetailPageURL)
					and $DetailPageURL = $item->DetailPageURL;
				
				$Title = NULL;
				isset($item->ItemAttributes->Title)
					and $Title = $item->ItemAttributes->Title;
	
				$opt = null;
				$opt['ResponseGroup'] = "Images,EditorialReview,ItemAttributes,Reviews,OfferSummary,Offers";
	
				// $ASIN = "B001RDVOFY"; // OMG TESTING - has features
				// $ASIN = "1584794747"; // OMG TESTING - no features
				$response = $aaws->item_lookup($ASIN, $opt, WPZonBuilder_LOCALE);
	
				// [images]
				$SmallImageURL = NULL;
				isset($response->body->Items->Item->SmallImage->URL)
					and $SmallImageURL = $response->body->Items->Item->SmallImage->URL;
				
				$MediumImageURL = NULL;
				isset($response->body->Items->Item->MediumImage->URL)
					and $MediumImageURL = $response->body->Items->Item->MediumImage->URL;
	
				// added in 1.15 case there is no small image at the above place in the array, we check this place too
				$ImageSet = NULL;
				isset($response->body->Items->Item->ImageSets->ImageSet[0])
					and $ImageSet = $response->body->Items->Item->ImageSets->ImageSet[0];
	
				if ($SmallImageURL == '') {
					isset($ImageSet->SmallImage->URL)
						and $SmallImageURL = $ImageSet->SmallImage->URL;
				}
				// [/images]
	
				// this is an array. index 0 should be the Product Description, index 1 should be the Amazon.com Product Description
				$EditorialReview = NULL;
				isset($response->body->Items->Item->EditorialReviews->EditorialReview)
					and $EditorialReview = $response->body->Items->Item->EditorialReviews->EditorialReview;
				
				$ProductDescription = NULL;
				isset($EditorialReview[0]->Content)
					and $ProductDescription = $EditorialReview[0]->Content;
	
				// this is an array. a product with no features won't have this set.
				$Features = null;
				if (isset($response->body->Items->Item->ItemAttributes->Feature)) {
					$Features = array();
					foreach ($response->body->Items->Item->ItemAttributes->Feature as $f) {
						$Features[] = (string) $f;
					}
				}
				
				$Price = NULL;
				isset($response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice)
					and $Price = $response->body->Items->Item->OfferSummary->LowestNewPrice->FormattedPrice;
	
				/*
				echo $Title."<br />";
				echo $ASIN."<br />";
				echo $DetailPageURL."<br />";
				echo $SmallImageURL."<br />";
				echo $MediumImageURL."<br />";
				echo $ProductDescription."<br />";
				echo $Features."<br />";
				echo $Price."<br />";
				*/
	
				$Availability = NULL;
				isset($response->body->Items->Item->Offers->Offer->OfferListing->Availability)
					and $Availability = $response->body->Items->Item->Offers->Offer->OfferListing->Availability;
	
	
				// [filtering]
				$filtered = false;
				?>
	
				<script>
				amznsetCookie("Filter_highprice", 				"<?php echo amzn_read_request("Filter_highprice"); ?>");
				amznsetCookie("Filter_lowprice", 				"<?php echo amzn_read_request("Filter_lowprice"); ?>");
				amznsetCookie("Filter_hasimage", 				"<?php echo amzn_read_request("Filter_hasimage"); ?>");
				amznsetCookie("Filter_noavailabilityinfo", 		"<?php echo amzn_read_request("Filter_noavailabilityinfo"); ?>");
				</script>
	
				<?php
				if (amzn_read_request("Filter_highprice") != '') {
					$Filter_highprice = floatval(amzn_read_request("Filter_highprice"));
				} else {
					$Filter_highprice = 1.0E+20;
				}
	
				if (amzn_read_request("Filter_lowprice") != '') {
					$Filter_lowprice = floatval(amzn_read_request("Filter_lowprice"));
				} else {
					$Filter_lowprice = 0;
				}
	
				if (amzn_read_request("Filter_hasimage") != '') {
					$Filter_hasimage = true;
				} else {
					$Filter_hasimage = false;
				}
	
				if (amzn_read_request("Filter_noavailabilityinfo") != '') {
					$Filter_noavailabilityinfo = true;
				} else {
					$Filter_noavailabilityinfo = false;
				}
	
	
				$testpricehere = AmazonAAWS_Locale::price_to_float($Price);
				
				if ($testpricehere < $Filter_lowprice) {
					$filtered = true;
				}
				if ($testpricehere > $Filter_highprice && $testpricehere > 0) {
					$filtered = true;
				}
				if ($Filter_noavailabilityinfo == true && $Availability == '') {
					$filtered = true;
				}
				if ($Filter_hasimage == true && $SmallImageURL == '') {
					$filtered = true;
				}
				if ($filtered == true) {
					?>
	
					<div class='amznitem' style='padding: 3px; text-align: center;'>
						<div class='amznlink'><a href='<?php echo $DetailPageURL; ?>' target='_blank'><?php echo $Title; ?></a> - <b>filtered</b></div>
					</div>
	
					<?php
					continue;
				}
				// [/filtering]
				?>
	
				<div class='amznitem'>
					<div class='amznthumb'>
						<img src='<?php echo $SmallImageURL; ?>' />
					</div>
	
					<div class='amzninfo'>
						<div class='amznlink'><a href='<?php echo $DetailPageURL; ?>' target='_blank'><?php echo $Title; ?></a></div>
						<div class='amznasin'><span>ASIN:</span> <?php echo $ASIN; ?></div>
						<div class='amznprice'><span>Price:</span> <?php echo $Price; ?></div>
					</div>
	
					<div class='amzncheck'>
						<div class='amzncheckbtn'>
							<?php
							$addedalready = false;
							if ($products != null) {
								foreach ($products as $product) {
									if ($product['asin'] == $ASIN) {
										$addedalready = true;
									}
								}
							}
	
							if ($addedalready == true) {
								$hideid = $ASIN."add"; // hide the add link if the product has already been added
							} else {
								$hideid = $ASIN."remove"; // hide the removal link if the product hasn't been added yet
							}
							?>
	
							<a id='<?php echo $ASIN; ?>remove' class='removelink' href='javascript:amznRemoveFromQueue("<?php echo $ASIN; ?>","<?php echo amzn_js_function_escape($Title); ?>");'>Remove From Queue</a>
	
							<a id='<?php echo $ASIN; ?>add'  class='addlink' href='javascript:amznToggleToQueue("<?php echo $ASIN; ?>","<?php echo amzn_js_function_escape($Title); ?>");'>Add To Queue</a>
	
							<script>
							document.getElementById("<?php echo $hideid; ?>").style.display = 'none';
							</script>
	
							<?php
							$bulkqueue[] = array("asin" => $ASIN, "title" => $Title);
							?>
						</div>
					</div>
					<br clear='all' />
				</div>
	
				<?php
			}
	
			amzn_paginate($url_to_here, $currentpage, $TotalPages, $TotalResults, $keyword);
		
		}

	}

	/*

	Search for items in a category, specify the sorting, enter a keyword

	the first page of products are loaded, showing the

	Thumbnail
	Title
	Rating
	ASIN
	Price
	number of Customer Reviews
	and whether Elegible for Free Shipping

	option to go to the next page

	*/
}


function amzn_paginate($url_to_here, $currentpage, $TotalPages, $TotalResults, $keyword) {

	$six = amzn_read_request("searchindexesselect");
	$sr = amzn_read_request("sortval");

	$filterstuff =
		"&Filter_highprice=".amzn_read_request('Filter_highprice').
		"&Filter_lowprice=".amzn_read_request('Filter_lowprice').
		"&Filter_minaveragerating=".amzn_read_request('Filter_minaveragerating').
		"&Filter_minreviews=".amzn_read_request('Filter_minreviews').
		"&Filter_hasimage=".amzn_read_request('Filter_hasimage').
		"&Filter_noavailabilityinfo=".amzn_read_request('Filter_noavailabilityinfo').
		"&browsenode=".amzn_read_request('browsenode');

	echo "<center>";

	echo "<p>";
	echo "<small>If you do not choose a Category/SearchIndex, Amazon only provides 5 pages of results. Otherwise, Amazon offers up to 10 pages of results.</small>";
	echo "</p>";

	if ($currentpage != 1) {
		echo "<a href='".$url_to_here."&currentpage=".($currentpage - 1)."&searchindexesselect=".$six."&sortval=".$sr."&keyword=".$keyword.$filterstuff."'>Previous Page</a>";
	}

	echo "&nbsp;&nbsp;";

	if ($currentpage != $TotalPages) {
		echo "<a href='".$url_to_here."&currentpage=".($currentpage + 1)."&searchindexesselect=".$six."&sortval=".$sr."&keyword=".$keyword.$filterstuff."'>Next Page</a>";
	}

	echo "<br />";

	echo "<a href='".$url_to_here."&currentpage=".(1)."&searchindexesselect=".$six."&sortval=".$sr."&keyword=".$keyword.$filterstuff."'>First</a>";
	echo " ... ";

	for ($i = 1; $i <= $TotalPages; $i++) {

		if ($i + 3 < $currentpage) {
			continue;
		}

		if ($i - 3 > $currentpage) {
			continue;
		}

		echo "<a href='".$url_to_here."&currentpage=".($i)."&searchindexesselect=".$six."&sortval=".$sr."&keyword=".$keyword.$filterstuff."'>".$i."</a>";
		echo "&nbsp;";

	}

	echo "... ";
	echo "<a href='".$url_to_here."&currentpage=".($TotalPages)."&searchindexesselect=".$six."&sortval=".$sr."&keyword=".$keyword.$filterstuff."'>Last</a>";

	echo "<br />";


	echo $TotalResults." results <small>(Amazon only allowing access to products on first ".$TotalPages." pages)</small> - showing page ".$currentpage ." of ".$TotalPages;

	echo "</center>";

}

