<?php

add_action("init", "amzn_rewrite");

function amzn_rewrite() {
	
	global $wpdb;

	if (get_option("amzn-trackclicks") == "Yes") {

		$url = get_option('siteurl');

		$method = "http://";

		if (isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == "on") {
			$method = "https://";
		}

		$request_uri = $method . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		$results = str_replace($url, "", $request_uri);

		// support for path_info urls.
		if(substr($results, 0, 10) == "/index.php") {
			$results = substr($results, 10, strlen($results));
		}

		$urlparts = explode("/", $results);

		$sepref = get_option('amzn-seoprefix');
		if ($sepref == "") {
			$sepref = "amzn";
		}

		if ($urlparts[1] == $sepref) {

			$postid = $urlparts[2];
			$asin = $urlparts[3];
			$where = $urlparts[4];

			$matchasin = get_post_meta($postid, "amzn_ASIN", true);

			if ($asin == $matchasin) { // OK, the ASIN matches the post, so we redirect based on the data for that post

				if ($where == 'AllCustomerReviews') {
					$URL = get_post_meta($postid, 'amzn_AllCustomerReviewsURL', true);
				} else if ($where == 'TellAFriend') {
					$URL = get_post_meta($postid, 'amzn_TellAFriendURL', true);
				} else {
					$URL = get_post_meta($postid, 'amzn_DetailPageURL', true);
				}

				if ($URL == "") get_post_meta($postid, 'amzn_DetailPageURL', true); // if the other URLs aren't set, send them to the detail page

				$title = get_post_meta($postid, 'amzn_Title', true);


			} else {

				$aaws = new AmazonAAWS();

				$pd = amzn_get_product_data($asin, $aaws);

				if ($where == 'AllCustomerReviews') {
					$URL = $pd['AllCustomerReviewsURL'];
				} else if ($where == 'TellAFriend') {
					$URL = $pd['TellAFriendURL'];
				} else {
					$URL = $pd['DetailPageURL'];
				}

				if ($URL == "") $URL = $pd['DetailPageURL']; // if the other URLs aren't set, send them to the detail page

				$title = $pd['Title'];

			}

			// check to see if amzn_overridetrack is set. If it is, override the affiliate ID with amzn_overridetrack.
			// if you change this, change the other code in the templates.php file

			$trackingid = get_post_meta($postid, 'amzn_overridetrack', true);
			if ($trackingid != '') {
				$URL = amzn_overridetrack($URL, $trackingid);
			}

			// -------------------

			// increment the post click counter

			$currentcount = get_post_meta($postid, 'amzn_ClickCount', true);
			$currentcount++;
			update_post_meta($postid, 'amzn_ClickCount', (string) $currentcount);

			// -----------

			// add new entry in clicks database table, with IP, post ID, destination URL, product Title, maybe ASIN, and maybe affiliate tracking ID
			// update posts meta table incrementing the click count

			$URL = urldecode($URL);

			$ipaddress = mysql_real_escape_string($_SERVER['REMOTE_ADDR']);
			
			$useragent = mysql_real_escape_string($_SERVER['HTTP_USER_AGENT']);

			$query = "
			INSERT INTO `".$wpdb->prefix."amznclicks` (
				`id` ,
				`ip` ,
				`postid` ,
				`destination` ,
				`title` ,
				`asin`,
				`time`,
				`useragent`
			)
			VALUES (
				NULL , '".$ipaddress."', '".$postid."', '".$URL."', '".$title."', '".$asin."', '".time()."', '".$useragent."'
			);";
			
			$wpdb->query($query);

			$header = 'Location: '.$URL;
			header($header);

			die();

		}
	}
}
