<?php

function amzn_bolder($array, $content, $prefix, $suffix) {
	$content = ' '.$content.' ';
	$search = Array();
	foreach ($array as $string) {
		$search[] = '/([^a-z])(' . preg_quote($string) . ')([^a-z])/i';
	}
	
	$prefix = str_replace(Array('\\', '$'), Array('\\\\', '\\$'), $prefix);
	$suffix = str_replace(Array('\\', '$'), Array('\\\\', '\\$'), $suffix);
	
	return substr(preg_replace($search, '$1' . $prefix . '$2' . $suffix . '$3', $content), 1, -1);
}


function amzn_situation_for_excerpt() {

	if (get_option("amzn-excerpts-home") == "Yes") {
		if (is_home()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-frontpage") == "Yes") {
		if (is_front_page()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-search") == "Yes") {
		if (is_search()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-category") == "Yes") {
		if (is_category()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-tag") == "Yes") {
		if (is_tag()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-author") == "Yes") {
		if (is_author()) {
			return true;
		}
	}

	if (get_option("amzn-excerpts-date") == "Yes") {
		if (is_date()) {
			return true;
		}
	}

	return false;
}


function amzn_product_post_shortcode($atts) {

	// asin does not matter, the asin is pulled from the post meta. so you should ditch this attribute.
	extract(
		shortcode_atts(
			array(
				'asin' => 'asin',
				'template' => 'single'
			),
			$atts
		)
	);
	
	$amzntemplate = $template;

	global $post;
	$postid = $post->ID;

	// if is a feed, just return something nice
	if (is_feed()) {
		return $ProductDescription 				= get_post_meta($postid, 'amzn_ProductDescription', true);
	}
	// ------------------------

	// make post excerpt

	$make_excerpt = amzn_situation_for_excerpt();

	if ($make_excerpt == true) {
		if (get_option("amzn-excerpts-short") == "Yes") {
			$product_data = amzn_product_from_meta($postid);
			$template = amzn_get_template("short");
			$content = amzn_process_template($product_data, $template);

			return $content;
		}

		$ProductDescription = get_post_meta($postid, 'amzn_ProductDescription', true);

		$length_of_excerpt = get_option('amzn-length_of_excerpt');

		$endof = get_option('amzn-excerpt_link');
		$endof = str_replace("[permalink]", get_permalink($post->ID), $endof);

		if (strlen($ProductDescription) > $length_of_excerpt) {
			$excerpt = substr($ProductDescription, 0, $postid);
			return $excerpt.$endof;
		} else {
			return $ProductDescription.$endof;
		}
	}


	$content = amzn_product_post_shortcode_content($asin, $amzntemplate);

	// rich snippets
	if (get_option('amzn-rdfa_aggregate') == "Yes") {
		if (is_single() || is_page()) {
			$content .= amzn_rdfa_aggregate_reviews($postid);
		}
	}
	if (get_option('amzn-rdfa_product') == "Yes") {
		if (is_single() || is_page()) {
			$content .= amzn_rdfa_product($postid);
		}
	}
	// -----------
	
	return $content;

}


function amzn_product_post_excerpt_shortcode($atts) {

	// asin does not matter, the asin is pulled from the post meta. so you should ditch this attribute.
	extract(
		shortcode_atts(
			array(
				'asin' => 'asin',
				'template' => 'single'
			),
			$atts
		)
	);
	
	$amzntemplate = $template;


	$content = amzn_product_post_shortcode_content($asin, $amzntemplate);

	return $content;

}


add_shortcode('amzn_product_post', 'amzn_product_post_shortcode');
add_shortcode('amzn_product_post_excerpt', 'amzn_product_post_excerpt_shortcode');


function amzn_product_post_shortcode_content($asin, $template = "single") {

	// $asin does not matter, the asin is pulled from the post meta. so you should ditch this attribute.

	global $post;
	$postid = $post->ID;


	// Data expiry

	if (get_option("amzn-dataexpiry") == "Yes") {

		$ASIN = get_post_meta($postid, "amzn_ASIN", true);
		$time = time();

		$recency = get_post_meta($postid, "amzn_recency", true);

		if ($recency == null) {
			update_post_meta($postid, "amzn_recency", (string) $time);
			$recency = get_post_meta($postid, "amzn_recency", true);
		}

		$days = get_option("amzn-dataexpirydays");
		if ($days == null) {
			$days = 7;
		}

		$interval = 60 * 60 * 24 * $days; // 60 * 60 * 24 * 7 is 1 week

		if ($recency + $interval < $time) { // if data is older than interval
			$aaws = new AmazonAAWS();
			amzn_product_to_meta($postid, amzn_get_product_data($ASIN, $aaws), true); // reload data
		}
		
	}

	// -----------------
	
	// customer reviews as iframe - you can use &TruncateReviewsAt=256 / &truncate=256. details here: http://developer.amazonwebservices.com/connect/thread.jspa?threadID=51231
	
	// if is expired
	
	$time = time();
	$recency = null;
	$recency = get_post_meta($postid, "amzn_iframerecency", true);

	if (!$recency) {
					
		update_post_meta($postid, "amzn_iframerecency", (string) $time);
	}
			
	$interval = 60 * 60 * 23; // 60 * 60 * 23 is 23 hours. iframes expire after 24 hours.

	if ($recency + $interval < $time) { // if data is older than interval

		$ASIN = get_post_meta($postid, "amzn_ASIN", true);

		$aaws = new AmazonAAWS();

		$opt = null;
		$opt['ResponseGroup'] = "Reviews";
		$response = $aaws->item_lookup($ASIN, $opt, WPZonBuilder_LOCALE);
	
		$IFrameURL = NULL;
		isset($response->body->Items->Item->CustomerReviews->IFrameURL)
			and $IFrameURL = $response->body->Items->Item->CustomerReviews->IFrameURL;
		
		if (get_option('amzn-iframetruncate') != '') {
			$apptourlxx = "&truncate=".get_option('amzn-iframetruncate');
			$IFrameURL .= $apptourlxx;
		}
					
		update_post_meta($postid, "amzn_IFrameURL", (string) $IFrameURL);
		
	}

	//  -------------------------
	
	$product_data = amzn_product_from_meta($postid);
	extract($product_data);

	// alternate gallery
	if (get_option('amzn-fancybox') == "Yes") {

		if (is_single() || is_page()) {

			$galleryhtml = amzn_build_gallery($ImageSets);
			$product_data['galleryhtml'] = $galleryhtml;

		} else {

			$product_data['galleryhtml'] = '';

		}

	}
	// --------------

	// auto-link images in product descriptions
	if (get_option("amzn-autolinkimages") == "Yes") {

		$newwind = "";
		if (get_option("amzn-newwindow") == "Yes") {
			$newwind = "target='_blank'";
		}

		$relnofollow = "";
		if (get_option("amzn-relnofollow") == "Yes") {
			$relnofollow = "rel='nofollow'";
		}

		$product_data['ProductDescription'] = amzn_add_links_to_description("<a href='[DetailPageURL]' ".$newwind." ".$relnofollow." >", "</a>", $product_data['ProductDescription']);
	}
	// --------------------------

	// ----- auto bold -----
	if (trim(get_option("amzn-autobold")) != "") {
		$barr = get_option("amzn-autobold");
		$barr = str_replace("\r", "", $barr);
		$barr = explode("\n", $barr);
				
		$product_data['ProductDescription'] = amzn_bolder($barr, $product_data['ProductDescription'], "<strong>", "</strong>");
	}
	
	if (get_post_meta($postid, "amzn_autobold", true) != "") {
		$barr = get_post_meta($postid, "amzn_autobold", true);
		$barr = str_replace("\r", "", $barr);
		$barr = explode("\n", $barr);
		$product_data['ProductDescription'] = amzn_bolder($barr, $product_data['ProductDescription'], "<strong>", "</strong>");
	}
	// --------------------------
	
	$product_data['IFrameURL'] = $IFrameURL;
	
	$template = amzn_get_template($template);
	$content = amzn_process_template($product_data, $template);

	$content2 = '';
	$videoids = amzn_youtube_vids($postid);

	if ($videoids != null) {
		foreach ($videoids as $videoid) {
			$template = amzn_get_template("video");
			$content2 .= amzn_video_template($videoid, $template);
		}
	}

	$retval = $content.$content2;

	return $retval;
}


add_shortcode('amzn_product_inline', 'amzn_product_inline_shortcode');
function amzn_product_inline_shortcode($atts) {

	extract(
		shortcode_atts(
			array(
				'asin' => 'asin',
				'template' => 'inlinesingle'
			),
			$atts
		)
	);

	$aaws = new AmazonAAWS();
	$product_data = amzn_get_product_data($asin, $aaws);
	$template = amzn_get_template($template);

	$content = amzn_process_template($product_data, $template);

	return $content;
}


add_shortcode('amzn_multi_product_inline', 'amzn_multi_product_inline_shortcode');
function amzn_multi_product_inline_shortcode($atts) {

	$aaws = new AmazonAAWS();
	$content = "";

	extract(
		shortcode_atts(
			array(
				'template' => 'inlinemulti',
				'keyword' => 'keyword',
				'count' => '5',
				'category' => '',
				'page' => '1',
				'sort' => 'default'
			),
			$atts
		)
	);
	
	$amzntemplate = $template;

	$page = $page * 1;
	if ($page == 0) $page = 1;
	if ($page > 10) $page = 10; // Amazon says max of 10 pages

	$se = $category;


	$opt = null;
	if ($sort != 'default') {
		$opt['Sort'] = $sort;
	}
	$opt['ItemPage'] = $page;
	if ($se != '') {
		$opt['SearchIndex'] = $se;
	}

	$search = $aaws->item_search($keyword, $opt, WPZonBuilder_LOCALE);

	$Items = $search->body->Items->Item;

	if ($Items == null) {
		echo WPZonBuilder_WEBSERVICEERROR;
	}

	$currentcount = 0;
	foreach ($Items as $item) {
		$currentcount++;
		if ($currentcount > $count) {
			break;
		}

		$ASIN = $item->ASIN;
		$DetailPageURL = $item->DetailPageURL;
		$Title = $item->ItemAttributes->Title;

		$product_data = amzn_get_product_data($ASIN, $aaws);
		$template = amzn_get_template($amzntemplate);

		$content .= amzn_process_template($product_data, $template);

	}

	return $content;

}
