<?php

/*

DISCLAIMER: THIS FILE IS NOT PART OF WPZONBUILDER, AND IS INCLUDED FOR YOUR CONVENIENCE. THIS FILE IS LICENSED UNDER THE GPL; WPZONBUILDER IS NOT. THE WP ZON BUILDER LICENSE IS AVAILABLE ONLINE AT HTTP://WPZONBUILDER.COM/

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

All code in this file is released under the GPL and is taken from the Auto Post Thumbnail plugin, with minor modifications - the function name was changed to prevent conflicts, and the arguments were changed to make is usable as an "API"-style function.

Auto Post Thumbnail: http://wordpress.org/extend/plugins/auto-post-thumbnail/
Copyright 2009  Aditya Mooley  (email : adityamooley@sanisoft.com), 

The code contained this file is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


*/



function newpref_generate_post_thumb($imageUrl, $post_id)
{
    // Get the file name
    $filename = substr($imageUrl, (strrpos($imageUrl, '/'))+1);
    
    $filename = str_replace("%", "-", $filename);
    
    if (!(($uploads = wp_upload_dir(current_time('mysql')) ) && false === $uploads['error'])) {
        return null;
    }

    // Generate unique file name
    $filename = wp_unique_filename( $uploads['path'], $filename );

    // Move the file to the uploads dir
    $new_file = $uploads['path'] . "/$filename";
    
    $file_data = amzn_file_get_contents($imageUrl);
    
    if (!$file_data) {
        return null;
    }
    
    file_put_contents($new_file, $file_data);

    // Set correct file permissions
    $stat = stat( dirname( $new_file ));
    $perms = $stat['mode'] & 0000666;
    @ chmod( $new_file, $perms );

    // Get the file type. Must to use it as a post thumbnail.
    isset($mimes) or $mimes = NULL;
    $wp_filetype = wp_check_filetype( $filename, $mimes );

    extract( $wp_filetype );

    // No file type! No point to proceed further
    if ( ( !$type || !$ext ) && !current_user_can( 'unfiltered_upload' ) ) {
        return null;
    }

    // Compute the URL
    $url = $uploads['url'] . "/$filename";

    // Construct the attachment array
    $attachment = array(
        'post_mime_type' => $type,
        'guid' => $url,
        'post_parent' => null,
        'post_title' => '',
        'post_content' => '',
    );

    isset($file) or $file = NULL;
    $thumb_id = wp_insert_attachment($attachment, $file, $post_id);
    if ( !is_wp_error($thumb_id) ) {
        require_once(ABSPATH . '/wp-admin/includes/image.php');
        
        wp_update_attachment_metadata( $thumb_id, wp_generate_attachment_metadata( $thumb_id, $new_file ) );

       	update_post_meta( $post_id, '_thumbnail_id', $thumb_id );

        return $thumb_id;
    }

    return null;
}

