<?php

// PRODUCTS FROM A CATEGORY

function amzn_display_widgetcategories($args) {

	global $wpdb;

	extract($args);

	$options = get_option('amzn-widgetcategories-options');
	
	$myposts = get_posts('numberposts='.$options['number'].'&category='.$options['id']);

	echo $before_widget;

	echo $before_title;
	echo str_replace("[title]", $options['title'], amzn_get_template("categorywidgettitle"));
	echo $after_title;

	$count = 0;

	foreach ($myposts as $post) {

		$pd = amzn_product_from_meta($post->ID);
		$content = amzn_process_template($pd, amzn_get_template("categorywidget") );
		echo $content;

	}

	echo $after_widget;

}


function amzn_display_widgetcategories_control() {

	$option_name = 'amzn-widgetcategories-options';

	if ($_POST['amzn-widgetcategories-submit'] ) {
		$optionsarr['id'] = strip_tags(stripslashes($_POST['amzn-widgetcategories-id']));
		$optionsarr['number'] = strip_tags(stripslashes($_POST['amzn-widgetcategories-number']));
		$optionsarr['title'] = strip_tags(stripslashes($_POST['amzn-widgetcategories-title']));

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>Title</b><br />
	<input type="text" name="amzn-widgetcategories-title" value="<?php echo $values['title']; ?>" /><br /><br />

	<b>Category ID</b><br />
	<input type="text" name="amzn-widgetcategories-id" value="<?php echo $values['id']; ?>" /><br /><br />

	<b>Number of Posts</b><br />
	<input type="text" name="amzn-widgetcategories-number" value="<?php echo $values['number']; ?>" /><br /><br />

	This widget will display the specified number of Amazon product posts in the category you specify. Make sure the category you specify here ONLY has Amazon product posts.

	<br /><br />

	<input type="hidden" name="amzn-widgetcategories-submit" id="amzn-widgetcategories-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_widgetcategories() {
	wp_register_sidebar_widget('amzn_widget_categories', 'WPZonBuilder Categories', 'amzn_display_widgetcategories');
    wp_register_widget_control('amzn_widget_categories', 'WPZonBuilder Categories', 'amzn_display_widgetcategories_control');
}

add_action('init', 'init_amzn_display_widgetcategories');

// ----------------------------------------------------


// ACCESSORY PRODUCTS

function amzn_display_accessories($args) {

	global $wpdb;

	extract($args);

	$options = get_option('amzn-accessory-options');

	if ($options['singleonly'] == "Yes") {
		if (is_home()) {
			return;
		}
	}

	if ( ! is_single()) {
		$regetsim = true;
	} else {
		global $post;
		$postid = $post->ID;

		$Accessories = unserialize(get_post_meta($postid, "amzn_Accessories_serialize", true));

		if ($Accessories == null) {
			$regetsim = true;
		}
	}

	if ($regetsim == true) {

		$opt = null;
		$opt['ResponseGroup'] = "Similarities,Accessories";

		$aaws = new AmazonAAWS();

		$response = $aaws->item_lookup($options['asin'], $opt, WPZonBuilder_LOCALE);

		$Accessories = null;
		if (isset($response->body->Items->Item->Accessories->Accessory)) {
			$Accessories = array();
			foreach ($response->body->Items->Item->Accessories->Accessory as $f) {
				$Accessories[] = array("ASIN" => (string) $f->ASIN, "Title" => (string) $f->Title);
			}
		}
	}

	if ($Accessories != null) {

		echo $before_widget;

		if (!$aaws) {
			$aaws = new AmazonAAWS();
		}

		echo $before_title;
		echo str_replace("[title]", $options['title'], amzn_get_template("accessorywidgettitle"));
		echo $after_title;

		$count = 0;

		foreach ($Accessories as $sim) {

			$count++;

			if ($count > $options['number']) {
				break;
			}

			$asin = $sim['ASIN'];

			$pd = amzn_get_product_data($asin, $aaws, true);
			$content = amzn_process_template($pd, amzn_get_template("accessorywidget") );
			echo $content;

		}

		echo $after_widget;
	}
}


function amzn_display_accessories_control() {

	$option_name = 'amzn-accessory-options';

	if ($_POST['amzn-accessory-submit'] ) {
		$optionsarr['title'] = strip_tags(stripslashes($_POST['amzn-accessory-title']));
		$optionsarr['asin'] = strip_tags(stripslashes($_POST['amzn-accessory-asin']));
		$optionsarr['number'] = strip_tags(stripslashes($_POST['amzn-accessory-number']));
		$optionsarr['singleonly'] = strip_tags(stripslashes($_POST['amzn-accessory-singleonly']));

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>Widget Title</b><br />
	<input type="text" name="amzn-accessory-title" value="<?php echo $values['title']; ?>" /><br /><br />

	<b>Default ASIN</b><br />
	<small>If there are no accessory products or the widget is not being displayed on a single post page, the accessory products will be used from the product with this ASIN instead.</small>
	<input type="text" name="amzn-accessory-asin" value="<?php echo $values['asin']; ?>" /><br /><br />

	<b>Number Of Items</b><br />
	<small>Maximum of 5</small><br />
	<input type="text" name="amzn-accessory-number" value="<?php echo $values['number']; ?>" /><br /><br />

	<b>Only Show Widget On Single Post Pages</b> <input type="checkbox" name="amzn-accessory-singleonly" value="Yes" <?php if ($values['singleonly']=="Yes") echo "checked"; ?> /><br /><br />


	<br /><br />

	<input type="hidden" name="amzn-accessory-submit" id="amzn-accessory-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_accessories() {
	wp_register_sidebar_widget('amzn_widget_accessories', 'WPZonBuilder Accessories', 'amzn_display_accessories');
    wp_register_widget_control('amzn_widget_accessories', 'WPZonBuilder Accessories', 'amzn_display_accessories_control');
}

add_action('init', 'init_amzn_display_accessories');

// ----------------------------------------------------


// SIMILAR PRODUCTS

function amzn_display_similarproducts($args) {

	global $wpdb;

	extract($args);

	$options = get_option('amzn-similar-options');

	if ($options['singleonly'] == "Yes") {
		if (is_home()) {
			return;
		}
	}

	$regetsim = false;
	if ( ! is_single()) {
		$regetsim = true;
	} else {

		global $post;
		$postid = $post->ID;

		$SimilarProducts = unserialize(get_post_meta($postid, "amzn_SimilarProducts_serialize", true));

		if ($SimilarProducts == null) {
			$regetsim = true;
		}
	}

	if ($regetsim == true) {

		$opt = null;
		$opt['ResponseGroup'] = "Similarities,Accessories";

		$aaws = new AmazonAAWS();

		$response = $aaws->item_lookup($options['asin'], $opt, WPZonBuilder_LOCALE);

		$SimilarProducts = null;
		if (isset($response->body->Items->Item->SimilarProducts->SimilarProduct)) {
			foreach ($response->body->Items->Item->SimilarProducts->SimilarProduct as $f) {
				$SimilarProducts[] = array("ASIN" => (string) $f->ASIN, "Title" => (string) $f->Title);
			}
		}
	}

	if ($SimilarProducts != null) {

		echo $before_widget;

		if (empty($aaws)) {
			$aaws = new AmazonAAWS();
		}

		echo $before_title;
		echo str_replace("[title]", $options['title'], amzn_get_template("similarwidgettitle"));
		echo $after_title;

		$count = 0;

		foreach ($SimilarProducts as $sim) {

			$count++;

			if ($count > $options['number']) {
				break;
			}

			$asin = $sim['ASIN'];

			$pd = amzn_get_product_data($asin, $aaws, true);
			$content = amzn_process_template($pd, amzn_get_template("similarwidget") );
			echo $content;

		}

		echo $after_widget;

	}
}


function amzn_display_similarproducts_control() {

	$option_name = 'amzn-similar-options';

	if ($_POST['amzn-similar-submit'] ) {
		$optionsarr['title'] = strip_tags(stripslashes($_POST['amzn-similar-title']));
		$optionsarr['asin'] = strip_tags(stripslashes($_POST['amzn-similar-asin']));
		$optionsarr['number'] = strip_tags(stripslashes($_POST['amzn-similar-number']));
		$optionsarr['singleonly'] = strip_tags(stripslashes($_POST['amzn-similar-singleonly']));

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);

	?>

	<div>

	<b>Widget Title</b><br />
	<input type="text" name="amzn-similar-title" value="<?php echo $values['title']; ?>" /><br /><br />

	<b>Default ASIN</b><br />
	<small>If there are no similar products or the widget is not being displayed on a single post page, the similar products will be used from the product with this ASIN instead.</small>
	<input type="text" name="amzn-similar-asin" value="<?php echo $values['asin']; ?>" /><br /><br />

	<b>Number Of Items</b><br />
	<small>Maximum of 5</small><br />
	<input type="text" name="amzn-similar-number" value="<?php echo $values['number']; ?>" /><br /><br />

	<b>Only Show Widget On Single Post Pages</b> <input type="checkbox" name="amzn-similar-singleonly" value="Yes" <?php if ($values['singleonly']=="Yes") echo "checked"; ?> /><br /><br />


	<br /><br />

	<input type="hidden" name="amzn-similar-submit" id="amzn-similar-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_similarproducts() {
	wp_register_sidebar_widget('amzn_widget_similarproducts', 'WPZonBuilder Similar Products', 'amzn_display_similarproducts');
    wp_register_widget_control('amzn_widget_similarproducts', 'WPZonBuilder Similar Products', 'amzn_display_similarproducts_control');
}


add_action('init', 'init_amzn_display_similarproducts');

// ----------------------------------------------------


// POST OR PAGE IN SIDEBAR

function amzn_display_postpage($args) {

	global $wpdb;

	extract($args);

	echo $before_widget;

	$options = get_option('amzn-display-postpage-options');
	$post = get_post($options['id']);

	setup_postdata($post);
	the_content();

	echo $after_widget;

}


function amzn_display_postpage_control() {

	$option_name = 'amzn-display-postpage-options';

	if ($_POST['amzn-display-postpage-submit'] ) {
		$optionsarr['id'] = strip_tags(stripslashes($_POST['amzn-display-id']));

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>Post/Page ID</b><br />
	<small><a href='javascript:alert("Go to your Edit Post/Edit Page screen. In the address bar, you will see a URL that ends with \"post.php?action=edit&post=XX\". XX is the post ID.");'>Click here to learn how find the ID.</a></small><br />
	<input type="text" name="amzn-display-id" value="<?php echo $values['id']; ?>" /><br />

	<br /><br />

	<input type="hidden" name="amzn-display-postpage-submit" id="amzn-display-postpage-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_postpage() {
	wp_register_sidebar_widget('amzn_widget_postpage', 'WPZonBuilder Display Page/Post', 'amzn_display_postpage');
    wp_register_widget_control('amzn_widget_postpage', 'WPZonBuilder Display Page/Post', 'amzn_display_postpage_control');
}


add_action('init', 'init_amzn_display_postpage');

// ----------------------------------------------------


// IMAGE WIDGET

function amzn_display_image($args) {

	global $wpdb;

	extract($args);

	echo $before_widget;

	$options = get_option('amzn-display-image-options');
	$imgurl = $options['imgurl'];
	$imgwidth = $options['imgwidth'];
	$imgheight = $options['imgheight'];
	$imgalt = $options['imgalt'];

	if ($imgwidth != '' && $imgheight != '') {
		echo "<img src='".$imgurl."' alt='".$imgalt."' width='".$imgwidth."' height='".$imgheight."' />";
	} else {
		echo "<img src='".$imgurl."' alt='".$imgalt."' />";
	}

	echo $after_widget;

}


function amzn_display_image_control() {

	$option_name = 'amzn-display-image-options';

	if ($_POST['amzn-display-image-submit'] ) {
		$optionsarr['imgurl'] = strip_tags(stripslashes($_POST['amzn-display-imgurl']));
		$optionsarr['imgwidth'] = strip_tags(stripslashes($_POST['amzn-display-width']));
		$optionsarr['imgheight'] = strip_tags(stripslashes($_POST['amzn-display-height']));
		$optionsarr['imgalt'] = strip_tags(stripslashes($_POST['amzn-display-imgalt']));

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);

	?>

	<div>

	<b>Image URL</b><br />
	<input type="text" name="amzn-display-imgurl" value="<?php echo $values['imgurl']; ?>" /><br />

	<b>Alt Text</b><br />
	<input type="text" name="amzn-display-imgalt" value="<?php echo $values['imgalt']; ?>" /><br />

	<b>Width x Height (pixels)</b><br />
	<input type="text" name="amzn-display-width" style='width: 40px;' maxlength='4' value="<?php echo $values['imgwidth']; ?>" /> x
	<input type="text" name="amzn-display-height" style='width: 40px;' maxlength='4' value="<?php echo $values['imgheight']; ?>" />

	<br /><br />

	<input type="hidden" name="amzn-display-image-submit" id="amzn-display-image-submit" value="1" />

	</div>

	<?php

}


function init_amzn_display_image() {
	wp_register_sidebar_widget('amzn_widget_image', 'WPZonBuilder Display Image', 'amzn_display_image');
    wp_register_widget_control('amzn_widget_image', 'WPZonBuilder Display Image', 'amzn_display_image_control');
}


add_action('init', 'init_amzn_display_image');

// ----------------------------------------------------



// ABOUT ME WIDGET

function amzn_display_imagetext($args) {

	global $wpdb;

	extract($args);

	echo $before_widget;

	$options = get_option('amzn-display-imagetext-options');
	$imgurl = $options['imgurl'];
	$imgwidth = $options['imgwidth'];
	$imgheight = $options['imgheight'];
	$imgalt = $options['imgalt'];
	$abouttext = $options['abouttext'];

	echo "<center>";
	if ($imgwidth != '' && $imgheight != '') {
		echo "<img src='".$imgurl."' alt='".$imgalt."' width='".$imgwidth."' height='".$imgheight."' />";
	} else {
		echo "<img src='".$imgurl."' alt='".$imgalt."' />";
	}
	echo "</center>";
	echo "<br />";

	echo $abouttext;

	echo $after_widget;

}


function amzn_display_imagetext_control() {

	$option_name = 'amzn-display-imagetext-options';

	if ($_POST['amzn-display-imagetext-submit'] ) {
		$optionsarr['imgurl'] = strip_tags(stripslashes($_POST['amzn-display-imgurl']));
		$optionsarr['imgwidth'] = strip_tags(stripslashes($_POST['amzn-display-width']));
		$optionsarr['imgheight'] = strip_tags(stripslashes($_POST['amzn-display-height']));
		$optionsarr['imgalt'] = strip_tags(stripslashes($_POST['amzn-display-imgalt']));
		$optionsarr['abouttext'] = stripslashes($_POST['amzn-display-abouttext']);

		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>Image URL</b><br />
	<input type="text" name="amzn-display-imgurl" value="<?php echo $values['imgurl']; ?>" /><br />

	<b>Alt Text</b><br />
	<input type="text" name="amzn-display-imgalt" value="<?php echo $values['imgalt']; ?>" /><br />

	<b>Width x Height (pixels)</b><br />
	<input type="text" name="amzn-display-width" style='width: 40px;' maxlength='4' value="<?php echo $values['imgwidth']; ?>" /> x
	<input type="text" name="amzn-display-height" style='width: 40px;' maxlength='4' value="<?php echo $values['imgheight']; ?>" />

	<br /><br />

	<b>About "Me" Text</b>
	<textarea name='amzn-display-abouttext' cols='24' rows='10'><?php echo $values['abouttext']; ?></textarea>

	<input type="hidden" name="amzn-display-imagetext-submit" id="amzn-display-imagetext-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_imagetext() {
	wp_register_sidebar_widget('amzn_widget_imagetext', 'WPZonBuilder About "Me" Box', 'amzn_display_imagetext');
    wp_register_widget_control('amzn_widget_imagetext', 'WPZonBuilder About "Me" Box', 'amzn_display_imagetext_control');
}


add_action('init', 'init_amzn_display_imagetext');

// ----------------------------------------------------


// BLANK SPACE WIDGET

function amzn_display_blankspace($args) {

	global $wpdb;

	extract($args);

	echo $before_widget;

	$options = get_option('amzn-display-blankspace-options');
	$height = $options['height'];

	echo "<div style='height: ".$height."px;'> </div>";

	echo $after_widget;

}


function amzn_display_blankspace_control() {

	$option_name = 'amzn-display-blankspace-options';

	if ($_POST['amzn-display-blankspace-submit'] ) {
		$optionsarr['height'] = strip_tags(stripslashes($_POST['amzn-display-height']));
		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>Height (px)</b><br />
	<input type="text" name="amzn-display-height" style='width: 40px;' maxlength='4' value="<?php echo $values['height']; ?>" />

	<input type="hidden" name="amzn-display-blankspace-submit" id="amzn-display-blankspace-submit" value="1" />

	</div>

	<?php
}


function init_amzn_display_blankspace() {
	wp_register_sidebar_widget('amzn_widget_blankspace', 'WPZonBuilder Blank Space', 'amzn_display_blankspace');
    wp_register_widget_control('amzn_widget_blankspace', 'WPZonBuilder Blank Space', 'amzn_display_blankspace_control');
}


add_action('init', 'init_amzn_display_blankspace');

// ----------------------------------------------------


// YOUTUBE WIDGET

function amzn_widget_youtube($args) {

	global $wpdb;

	extract($args);

	echo $before_widget;

	$options = get_option('amzn-youtubewidget-options');
	$url = $options['url'];
	$width = $options['width'];
	$height = $options['height'];

	if ($url == '') {
		$url = "http://www.youtube.com/watch?v=yf4EaDtbBEk";
	}

	$vcode = explode("youtube.com/watch?v=", $url);
	$vcode = $vcode[1];

	$url = "http://www.youtube.com/v/".$vcode;

	if ($width == '') {
		$width = 425;
		$height = 344;
	}

	$content = '<object width="'.$width.'" height="'.$height.'"><param name="wmode" value="transparent" /><param name="movie" value="'.$url.'"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="'.$url.'" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$width.'" height="'.$height.'" wmode="transparent"></embed></object>';

	echo $content;

	echo $after_widget;

}


function amzn_widget_youtube_control() {

	$option_name = 'amzn-youtubewidget-options';

	if ($_POST['amzn-youtubewidget-submit'] ) {
		$optionsarr['url'] = strip_tags(stripslashes($_POST['youtubeurl']));
		$optionsarr['width'] = strip_tags(stripslashes($_POST['youtubewidth']));
		$optionsarr['height'] = strip_tags(stripslashes($_POST['youtubeheight']));
		update_option($option_name, $optionsarr);
	}

	$values = get_option($option_name);
	?>

	<div>

	<b>URL to YouTube Video</b><br />
	<input type="text" name="youtubeurl" style='width: 200px;' value="<?php echo $values['url']; ?>" />

	<br />

	<b>Width x Height (pixels)</b><br />
	<small>200 x 162 recommended</small><br />
	<input type="text" name="youtubewidth" style='width: 40px;' maxlength='4' value="<?php echo $values['width']; ?>" /> x
	<input type="text" name="youtubeheight" style='width: 40px;' maxlength='4' value="<?php echo $values['height']; ?>" />


	<input type="hidden" name="amzn-youtubewidget-submit" id="amzn-youtubewidget-submit" value="1" />

	</div>

	<?php
}


function init_amzn_widget_youtube() {
	wp_register_sidebar_widget('amzn_widget_youtube', 'WPZonBuilder YouTube', 'amzn_widget_youtube');
    wp_register_widget_control('amzn_widget_youtube', 'WPZonBuilder YouTube', 'amzn_widget_youtube_control');
}


add_action('init', 'init_amzn_widget_youtube');

// ----------------------------------------------------
